openerp.eiru_reporting = function (instance) {
    "use strict";

    var reporting = instance.eiru_reporting;

    //reportingBase
    reporting_base(instance,reporting);
    configuration_reporting(instance,reporting);


    // Lista de Reporte
    try {

        report_resumen_ingresos(reporting);
        report_resumen_egresos(reporting);
        report_vouchers(reporting);
        report_invoice_balance(reporting);
        report_invoice_difventa(reporting);
        report_utilidad_producto(reporting);
        report_sales_invoice_analysis(reporting);
        report_purchases_invoice_analysis(reporting);
        report_stock(reporting);
        report_stock_original(reporting);
        report_stock_move(reporting);
        report_crm(reporting);
        report_mensajecrm(reporting);
        report_crmtask(reporting);
        report_project(reporting);
        reporting_accountpending_pagar(reporting);
        reporting_accountpending(reporting);
        report_works(reporting);
        report_pos(reporting);
        report_rrhh(reporting);
        report_mrp(reporting);
	report_ranking_pos_orders_customer(reporting);
        report_ranking_sales_orders_customer(reporting);
        report_ranking_purchases_orders_supplier(reporting);
        ranking_pos_orders_product_cy(reporting);
        ranking_sales_orders_product_cy(reporting);
        ranking_mrp_orders_product_cy(reporting);
        report_product_pack_utilidad(reporting);
        report_product_pack(reporting);
        ranking_purchases_orders_product_cy(reporting);
        report_bank_movements(reporting);
        report_ventas_pos_orders(reporting);
        report_sale_cab(reporting);
        report_contratocliente(reporting);
        report_contratoproveedor(reporting);
        report_sale_pos_cab(reporting);
        report_pos_orders(reporting);

    } catch (e) {

        // ignorar error

    }

    // Todos los informes
    instance.web.client_actions.add('eiru_reporting.action_report', 'instance.eiru_reporting.ReportingWidget');

    // ******************************************* Finanzas **********************************************************************
    // Resumen de Ingresos
    instance.web.client_actions.add('eiru_reporting.ingreso_action_report', 'instance.eiru_reporting.ReportResumenIngresoWidget');
    // Resumen de Egresos
    instance.web.client_actions.add('eiru_reporting.egreso_action_report', 'instance.eiru_reporting.ReportResumenEgresoWidget');
    // Historico de facturas
    instance.web.client_actions.add('eiru_reporting.invoice_action_report', 'instance.eiru_reporting.ReportInvoiceBalanceWidget');
    // Historico de Movimiento de Banco
    instance.web.client_actions.add('eiru_reporting.bank_movements_action_report', 'instance.eiru_reporting.ReportBankMovementsWidget');
    // Historico de gral de Banco
    // instance.web.client_actions.add('eiru_reporting.bank_gral_action_report', 'instance.eiru_reporting.ReportBankGralWidget');
    // Historico de pagos
    instance.web.client_actions.add('eiru_reporting.voucher_action_report', 'instance.eiru_reporting.ReportVoucherWidget');
    // Listado de cuentas a cobrar
    instance.web.client_actions.add('eiru_reporting.account_action_report', 'instance.eiru_reporting.ReportingAccountPendingWidget');
    // Listado de cuentas a cobrar
    // instance.web.client_actions.add('eiru_reporting.account_action_report', 'instance.eiru_reporting.ReportingAccountWidget');

    // Listado de cuentas a pagar
    instance.web.client_actions.add('eiru_reporting.account_pending_action_report', 'instance.eiru_reporting.ReportingAccountPendingPagarWidget');

    // ******************************************* Ventas *************************************************************************
    // Historico de ventas
    instance.web.client_actions.add('eiru_reporting.sale_order_action_report', 'instance.eiru_reporting.ReportSaleCabWidget');

    // Analisis de ventas
    instance.web.client_actions.add('eiru_reporting.sale_action_report', 'instance.eiru_reporting.ReportSaleInvoiceAnalysisWidget');

    // Contrato Cliente
    instance.web.client_actions.add('eiru_reporting.contratocliente_action_report', 'instance.eiru_reporting.ReportContratoClienteWidget');

    // Ranking de clientes
    instance.web.client_actions.add('eiru_reporting.sale_customer_ranking_action_report', 'instance.eiru_reporting.ReportRankingSalesOrdersCustomerWidget');

    // Ranking de productos
    instance.web.client_actions.add('eiru_reporting.productranking_action_report', 'instance.eiru_reporting.RankingSalesOrdersProductcyWidget');

    // ******************************************* Terminal de Ventas *************************************************************************

    // Historico de ventas
    instance.web.client_actions.add('eiru_reporting.point_of_sale_action_report', 'instance.eiru_reporting.ReportPosWidget');

    // Analisis de ventas
    instance.web.client_actions.add('eiru_reporting.point_of_sale_detail_action_report', 'instance.eiru_reporting.ReportPosOrdersWidget');

    // Historico de ventas y pos
    instance.web.client_actions.add('eiru_reporting.sale_pos_order_action_report', 'instance.eiru_reporting.ReportSalePosCabWidget');

    // Analisis de pos y ventas
     instance.web.client_actions.add('eiru_reporting.point_venta_action_report', 'instance.eiru_reporting.ReportVentasPosOrdersWidget');

     // Analisis de diferencia de precios de venta porcentaje
     instance.web.client_actions.add('eiru_reporting.difventa_action_report', 'instance.eiru_reporting.ReportInvoiceDifventaWidget');

    // Ranking de productos
    instance.web.client_actions.add('eiru_reporting.point_of_sale_ranking_action_report', 'instance.eiru_reporting.RankingPosOrdersProductcyWidget');
     // Ranking de clientes
    instance.web.client_actions.add('eiru_reporting.point_of_sale_customer_ranking_action_report', 'instance.eiru_reporting.ReportRankingPosOrdersCustomerWidget');

    // ******************************************* Compras *************************************************************************
    // Analisis de compras
    instance.web.client_actions.add('eiru_reporting.purchase_detail_action_report', 'instance.eiru_reporting.ReportPurchaseInvoiceAnalysisWidget');
    // Contrato Cliente
    instance.web.client_actions.add('eiru_reporting.contratoproveedor_action_report', 'instance.eiru_reporting.ReportContratoProveedorWidget');

    // Ranking de productos
    instance.web.client_actions.add('eiru_reporting.product_ranking_action_report', 'instance.eiru_reporting.RankingPurchasesOrdersProductcyWidget');
    // Ranking proveedores
    instance.web.client_actions.add('eiru_reporting.suppliers_ranking_action_report', 'instance.eiru_reporting.ReportRankingPurchasesOrdersSupplierWidget');

    // Listado de cuentas a cobrar
    // instance.web.client_actions.add('eiru_reporting.accountpending_detail_action_report', 'instance.eiru_reporting.ReportingAccountaPagarWidget');


    // ******************************************* CRM ***************************************************************************
    // CRM
    instance.web.client_actions.add('eiru_reporting.crm_action_report', 'instance.eiru_reporting.ReportCrmWidget');
    // Historico de llamadas
    instance.web.client_actions.add('eiru_reporting.crm_task_action_report', 'instance.eiru_reporting.ReportCrmTaskWidget');
    // Historico de mensajes
    instance.web.client_actions.add('eiru_reporting.crm_messages_action_report', 'instance.eiru_reporting.ReportMensajeCrmWidget');
    // Proyectos
    instance.web.client_actions.add('eiru_reporting.project_action_report', 'instance.eiru_reporting.ReportProjectWidget');

    // ******************************************* Produccion ********************************************************************
    // Informe de trabajos
    instance.web.client_actions.add('eiru_reporting.work_action_report', 'instance.eiru_reporting.ReportWorksWidget');
    // Listado de produccion
    instance.web.client_actions.add('eiru_reporting.mrp_action_report', 'instance.eiru_reporting.ReportMrpWidget');
    // Ranking productos más producidos
    instance.web.client_actions.add('eiru_reporting.mrp_ranking_action_report', 'instance.eiru_reporting.RankingMrpOrdersProductcyWidget');

    // ******************************************* Stock *************************************************************************
    // Analisis de stock
    instance.web.client_actions.add('eiru_reporting.stock_action_report', 'instance.eiru_reporting.ReportStockWidget');

    // Analisis de stock original
    instance.web.client_actions.add('eiru_reporting.stock_original_action_report', 'instance.eiru_reporting.ReportStockOriginalWidget');

    // Analisis de movimientos de stock
    instance.web.client_actions.add('eiru_reporting.stock_move_action_report', 'instance.eiru_reporting.ReportStockMoveWidget');

    // Analisis de pack de productos
    instance.web.client_actions.add('eiru_reporting.product_pack_action_report', 'instance.eiru_reporting.ReportProductPackWidget');

    // Listado de produccion de pack utilidad
    instance.web.client_actions.add('eiru_reporting.mrp_utilidad_action_report', 'instance.eiru_reporting.ReportProductPackUtilidadWidget');

    // ******************************************* RRHH *************************************************************************
    // Analisis de RRHH
    instance.web.client_actions.add('eiru_reporting.rrhh_action_report', 'instance.eiru_reporting.ReportRrhhWidget');
}
