function ranking_mrp_orders_product_cy (reporting) {
    "use strict";

    var instance = openerp;

    reporting.RankingMrpOrdersProductcyWidget = reporting.Base.extend({
        template: 'RankingMrpOrdersProductcy',
        data: [],
        accountInvoice: [],
        invoiceLine: [],
        productProduct: [],
        productAtributo: [],
        ranking: [],
        content: [],
        modelId: [],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',

            'click #Y' : 'factSearch',
            'change #from' : 'factSearch',
            'change #to' : 'factSearch',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
            'click canvas': 'showCustomers',
            'click #volver_btn': 'volver',
        },
        init : function(parent){
            this._super(parent);
        },
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },

        // Redirecionar
        renderReport: function () {
            var self = this;

            var container = this.$el.closest('.oe_form_sheet.oe_form_sheet_width');
            this.$el.closest('.report_view').remove();
            container.find('.report_view').show({
                effect: 'fade',
                duration: 200,
            });
        },
        // Verificar el modelo
        checkModel : function(model){
            var self = this;
            return _.filter(self.modules,function(item){return item.name === model});
        },
        // Lanzar el mensaje
        showMensaje : function(modelos){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html('Reporte in-disponible, contacte con el administrador del sistema ref : '+modelos);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                        self.renderReport()
                    }
                }
            });
            return
        },

        submitForm: function () {
            var self = this;
            self.fecthIrModuleModule().then(function(modules){
                self.modules = modules;
                return modules;
            }).then(function(modules){
                return self.fetchMrp();
            }).then(function(Mrp) {
                self.Mrp = Mrp;
                return self.fetchProduct();
            }).then(function(productProduct){
                self.productProduct = productProduct;
                self.search();
                return self.BuildTable();
            });
        },

        // Modelos instalados
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed']];
            var irModule = new instance.web.Model('ir.module.module');

            irModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });

            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },

        fetchMrp: function () {
            var self = this;
            var defer = $.Deferred();
            var modules = self.checkModel('mrp');

            if (modules.length <= 0){
                self.showMensaje('mrp');
                return defer;
            }
            var filter =[['state', 'in',['done']]];
            var Mrp = new instance.web.Model('mrp.production');
            Mrp.query(['id', 'name', 'product_id', 'date_planned', 'product_qty', 'create_date', 'state']).filter(filter).all().then(function(results){
                defer.resolve(results);
            });

            return defer;
        },

        // ProductProduct
        fetchProduct: function() {
            var self = this;
            var defer = $.Deferred();
            var productProduct = new instance.web.Model('product.product');
            productProduct.query(['id','name','name_template']).filter([['active', '=', true]]).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },
        search: function () {
            var self = this;
            var results = self.productProduct;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '-'+ item.name,
                        value: item.id + '-'+ item.name
                }
            });
            self.$('#product').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#product').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },

        // Obtener facturas por cada prodcutos
        getMrpOrder:function(product_id) {
            var self = this;
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var Mrp = self.Mrp;
            // Hoy
            if ($('#A').is(":checked")){
                Mrp = _.filter(Mrp, function (inv){
                    return moment(inv.create_date).format('YYYY-MM-DD') == moment().format('YYYY-MM-DD');
                });
            }
            // Ayer
            if ($('#B').is(":checked")){
                Mrp = _.filter(Mrp, function (inv){
                    return moment(inv.create_date).format('YYYY-MM-DD') == moment().add(-1,'days').format('YYYY-MM-DD');
                });
            }
            // Mes Actual
            if ($('#C').is(":checked")){
                Mrp = _.filter(Mrp, function (inv){
                    return moment(inv.create_date).format('MM') == moment().format('MM');
                });
            }
            // Mes Pasado
            if ($('#D').is(":checked")){
                Mrp = _.filter(Mrp, function (inv){
                    return moment(inv.create_date).format('MM') == moment().add(-1,'months').format('MM');
                });
            }
            // Rango de fechas
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date = desde.split('/');
                    Mrp = _.filter(Mrp, function (inv){
                        return moment(inv.create_date).format('YYYY-MM-DD') >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    Mrp = _.filter(Mrp, function (inv){
                        return moment(inv.create_date).format('YYYY-MM-DD') <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }

            return _.flatten(_.filter(Mrp,function (inv) {
                return inv.product_id[0] === product_id;
            }));
        },

        // Generar el Ranking
        BuildTable: function() {
            var self = this;
            var itemProduct;
            var itemMrpOrder;
            var countMrpOrder = 0;
            var quantity = 0;
            var data = [];

            for (var i = 0; i < self.productProduct.length; i++) {
                itemProduct = self.productProduct[i];
                itemMrpOrder = self.getMrpOrder(itemProduct.id);

                quantity = _.reduce(_.map(itemMrpOrder,function(item) {
                    return item.product_qty;
                }),function(memo, num) {
                    return memo + num;
                },0);

                if(quantity > 0){
                    data.push({
                        id: itemProduct.id,
                        name: itemProduct.name,
                        countMrpOrder: accounting.formatNumber(quantity,0,".",","),
                        qty: quantity,
                        graficar: true
                    });
                }
            }

            data.sort(function (a, b) {
                return b.qty - a.qty
            });

            self.content = data;
            self.loadTable(data);
        },

        factSearch: function(){
            var self = this;

            var producto = this.$el.find('#product').val().split('-');
            var content = self.content;

            if (producto != ""){
                content = _.filter(content, function(inv){
                    return inv.id == producto[0];
                });
            }

            self.BuildTable();
            self.loadTable(content)
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },

        getObjetPdf: function(rowsTable){
            var self = this;
            var rows=self.rowsData;

            return rows;
        },

        // volver
        volver: function(){
            this.$el.find('#volver').empty();
            this.$el.find('#grafico').empty();
            this.$el.find('.bootstrap-table').show({
                effect: 'drop',
                direction: 'down',
                duration: 200,
            });
        },

        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjetPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabecera
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                            getColumns.push([{
                                        title: item.title,
                                        dataKey: item.field
                                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
            if (action === 'chart'){
                var self = this;
                var objetChar;
                objetChar = _.filter(rowsNew,function(item){return item.graficar === true});
                self.fectCharFilter(objetChar);
            }
        },
        drawPDF: function (getColumns,rows) {
            var self = this;
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    product : {columnWidth: '10px'},
                    qty : {halign:'right',columnWidth: '8px'},
                },
                margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Listado de producto más fabricados ', data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                        var fecha='';
                        if(desde){
                            fecha=fecha.concat(' Desde '+desde);
                        }
                        if (hasta){
                            fecha=fecha.concat(' Hasta '+hasta);
                        }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                    }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Listado de producto más fabricados.pdf')
        },
        // Char filter
        fectCharFilter: function(objetChar){
            var self = this;
            var dataBody=[];
            var dataHeader=[];
            // objetChar
            var canvas="<canvas id='graf_resume'></canvas>";
            this.$el.find('#grafico').append(canvas);
            _.each(objetChar,function(rowsNew){
                dataHeader.push(rowsNew.name);
                dataBody.push(parseFloat(((rowsNew.countMrpOrder.replace(".","")).replace(",","."))));
            });
            var selector ="<button type='button' class='oe_button oe_form_button oe_highlight' id='volver_btn' name='volver_btn'><span>Atras</span></button>";
            this.$el.find('#volver').append(selector);
            this.$el.find('.bootstrap-table').hide({
                    effect: 'drop',
                    direction: 'up',
                    duration: 200,
                    complete: function () {
                        self.drawChart(dataHeader,dataBody);
                    }
                });
        },
        //Chart
        drawChart: function (dataHeader,dataBody) {
            var barChart = new Chart(this.$el.find('#graf_resume'), {

                type: 'line',
                data: {
                    labels: dataHeader,
                    datasets: [
                        {
                            label: 'Cantidad de productos',
                            backgroundColor: '#e3f2fd',
                            borderColor: '#64b5f6',
                            borderWidth: 2,
                            data: dataBody,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    title: {
                        display: true,
                        text: 'Ranking de productos más producidos'
                    }
                }
            });
        },
        // llamar a la lista
        showCustomers: function (e) {
            var self = this;
            if (self.content.length === 0 ) {
                instance.web.notification.do_warn("Atención","Sin datos");
                return
            }
            var hoy = moment().format('YYYY-MM-DD');
            var product_id = _.map(self.content,function(map){
                return map.id;
            })
            this.do_action({
                // name: "Listado de productos más comprados",
                // type: 'ir.actions.act_window',
                // res_model: "product.product",
                // views: [[false,'list'],[self.modelId[1],'form']],
                // target: 'current',
                // domain: [['id', 'in', product_id]],
                // context: {},
            });
        }
    });
}
