function ranking_pos_orders_product_cy (reporting) {
    "use strict";

    var instance = openerp;

    reporting.RankingPosOrdersProductcyWidget = reporting.Base.extend({
        template: 'RankingPosOrdersProductcy',
        data: [],
        accountInvoice: [],
        invoiceLine: [],
        productProduct: [],
        productAtributo: [],
        ranking: [],
        content: [],
        modelId: [],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',

            'click #Y' : 'factSearch',
            'change #from' : 'factSearch',
            'change #to' : 'factSearch',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
            'click canvas': 'showCustomers',
            'click #volver_btn': 'volver',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },

        // Redirecionar
        renderReport: function () {
            var self = this;

            var container = this.$el.closest('.oe_form_sheet.oe_form_sheet_width');
            this.$el.closest('.report_view').remove();
            container.find('.report_view').show({
                effect: 'fade',
                duration: 200,
            });
        },
        // Verificar el modelo
        checkModel : function(model){
            var self = this;
            return _.filter(self.modules,function(item){return item.name === model});
        },

        // Lanzar el mensaje
        showMensaje : function(modelos){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html('Reporte in-disponible, contacte con el administrador del sistema ref : '+modelos);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                        self.renderReport()
                    }
                }
            });
            return
        },

        submitForm: function () {
            var self = this;
            self.fecthIrModuleModule().then(function(modules){
                self.modules = modules;
                return modules;
            }).then(function(modules){
                return self.fecthPosOrder();
            }).then(function (PosOrder) {
                self.PosOrder = PosOrder;
                return self.fecthPosOrderLine(PosOrder);
            }).then(function (PosOrderLine) {
                self.PosOrderLine = PosOrderLine;
                return self.fecthProductProduct(PosOrderLine);
            }).then(function(productProduct){
                self.productProduct = productProduct;
                self.search();
                return self.BuildTable();
            });
        },

        // Modelos instalados
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed']];
            var irModule = new instance.web.Model('ir.module.module');

            irModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });

            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },

        // Obtener Pedido
        fecthPosOrder: function() {
            var self = this;
            var defer = $.Deferred();
            var modules = self.checkModel('point_of_sale');

            if (modules.length <= 0){
                self.showMensaje('point_of_sale');
                return defer;
            }

            var fields = ['id', 'lines', 'date_order'];
            // var domain = [['date_order', '>=', desde], ['date_order', '<', hasta], ['state', 'in', ['paid','done','invoiced']]];
            var domain = [ ['state', 'in', ['paid','done','invoiced']]];
            var PosOrder = new instance.web.Model('pos.order');
            PosOrder.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },
        // Obtener linea de la factura
        fecthPosOrderLine: function(PosOrder) {
            var self = this;
            var defer = $.Deferred();
            var lines = _.flatten(_.map(PosOrder, function (item) {
                return item.lines;
            }));
            var fields = ['id', 'product_id', 'create_date', 'qty'];
            var domain = [['id','in', lines]];
            var PosOrderLine = new instance.web.Model('pos.order.line');
            PosOrderLine.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },
        // Obtener Productos
        fecthProductProduct: function (PosOrderLine) {
            var self = this;
            var defer = $.Deferred();
            var product_id = _.flatten(_.map(PosOrderLine,function (item) {
                return item.product_id[0];
            }));
            var fields = ['id', 'name','name_template', 'type', 'ean13','attribute_str'];
            var domain = [['id', 'in', product_id]];
            var ProductProduct = new instance.web.Model('product.product');
            ProductProduct.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        // Obtener facturas por cada clientes
        getPosOrderLiners:function(product_id) {
            var self = this;
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var PosOrderLine = self.PosOrderLine;
            // Hoy
            if ($('#A').is(":checked")){
                PosOrderLine = _.filter(PosOrderLine, function (inv){
                    return moment(inv.create_date).format('YYYY-MM-DD') == moment().format('YYYY-MM-DD');
                });
            }
            // Ayer
            if ($('#B').is(":checked")){
                PosOrderLine = _.filter(PosOrderLine, function (inv){
                    return moment(inv.create_date).format('YYYY-MM-DD') == moment().add(-1,'days').format('YYYY-MM-DD');
                });
            }
            // Mes Actual
            if ($('#C').is(":checked")){
                PosOrderLine = _.filter(PosOrderLine, function (inv){
                    return moment(inv.create_date).format('MM') == moment().format('MM');
                });
            }
            // Mes Pasado
            if ($('#D').is(":checked")){
                PosOrderLine = _.filter(PosOrderLine, function (inv){
                    return moment(inv.create_date).format('MM') == moment().add(-1,'months').format('MM');
                });
            }
            // Rango de fechas
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date = desde.split('/');
                    PosOrderLine = _.filter(PosOrderLine, function (inv){
                        return moment(inv.create_date).format('YYYY-MM-DD') >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    PosOrderLine = _.filter(PosOrderLine, function (inv){
                        return moment(inv.create_date).format('YYYY-MM-DD') <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }

            return _.flatten(_.filter(PosOrderLine,function (inv) {
                return inv.product_id[0] === product_id;
            }));
        },

        // Generar el ranking
        BuildTable: function() {
            var self = this;
            var itemProduct;
            var itemLine;
            var qty = 0;
            var ranking = [];
            var cat = 0;
            var countSalesOrder = 0;
            var attribute;
            var lineUnik;

            for (var i = 0; i < self.productProduct.length; i++) {
                itemProduct = self.productProduct[i];
                itemLine = self.getPosOrderLiners(itemProduct.id);
                if (itemLine.length > 0) {
                    cat = _.reduce(_.map(itemLine, function (map) {
                        return map.qty
                    }), function (meno,num) {
                        return meno + num
                    }, 0);

                    lineUnik = itemLine.shift();

                    if(itemProduct.attribute_str){
                        attribute = '*' + itemProduct.attribute_str;
                    }else{
                        attribute = ' ';
                    }

                    ranking.push({
                        product: itemProduct.name_template + ' ' + attribute,
                        qty: cat,
                        id: lineUnik.product_id[0],
                        date: moment(itemLine.create_date).format("YYYY-MM-DD"),
                        type: itemProduct.type,
                        countSalesOrder: accounting.formatNumber(cat,0,".",","),
                        graficar: true
                    });
                }
            }

            ranking.sort(function (a, b) {
                return b.qty - a.qty
            });

            self.content = ranking;
            self.loadTable(ranking);

        },

        search: function () {
            var self = this;
            var results = self.productProduct;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '- '+ ' [ ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) ' ,
                        value: item.id + '- '+ ' [ ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) '
                }
            });
            self.$('#product').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#product').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },

        factSearch: function(){
            var self = this;
            var product= this.$el.find('#product').val().split('-');
            var content = self.content;
            if (product != ""){
                content = _.filter(content, function(inv){
                    return inv.id == product[0];
                });
            }

            self.BuildTable();
            self.loadTable(content)
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },
        getObjetPdf: function(rowsTable){
            var self = this;
            var rows=self.rowsData;

            return rows;
        },

        // volver
        volver: function(){
            this.$el.find('#volver').empty();
            this.$el.find('#grafico').empty();
            this.$el.find('.bootstrap-table').show({
                effect: 'drop',
                direction: 'down',
                duration: 200,
            });
        },

        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjetPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                            getColumns.push([{
                                        title: item.title,
                                        dataKey: item.field
                                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
            if (action === 'chart'){
                var self = this;
                var objetChar;
                objetChar = _.filter(rowsNew,function(item){return item.graficar === true});
                self.fectCharFilter(objetChar);
            }
        },
        drawPDF: function (getColumns,rows) {
            var self = this;
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    product : {columnWidth: '10px'},
                    qty : {halign:'right',columnWidth: '8px'},
                    type : {halign:'left',columnWidth: '8px'},
                },
                margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Producto más vendidos Punto de Venta ', data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                        var fecha='';
                        if(desde){
                            fecha=fecha.concat(' Desde '+desde);
                        }
                        if (hasta){
                            fecha=fecha.concat(' Hasta '+hasta);
                        }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                    }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Producto más vendidos Punto de Venta.pdf')
        },
        // Char filter
        fectCharFilter: function(objetChar){
            var self = this;
            var dataBody=[];
            var dataHeader=[];
            // objetChar
            var canvas="<canvas id='graf_resume'></canvas>";
            this.$el.find('#grafico').append(canvas);
            _.each(objetChar,function(rowsNew){
                dataHeader.push(rowsNew.product);
                dataBody.push(parseFloat(((rowsNew.countSalesOrder.replace(".","")).replace(",","."))));
            });
            var selector ="<button type='button' class='oe_button oe_form_button oe_highlight' id='volver_btn' name='volver_btn'><span>Atras</span></button>";
            this.$el.find('#volver').append(selector);
            this.$el.find('.bootstrap-table').hide({
                    effect: 'drop',
                    direction: 'up',
                    duration: 200,
                    complete: function () {
                        self.drawChart(dataHeader,dataBody);
                    }
                });
        },
        //Chart
        drawChart: function (dataHeader,dataBody) {
            var barChart = new Chart(this.$el.find('#graf_resume'), {

                type: 'line',
                data: {
                    labels: dataHeader,
                    datasets: [
                        {
                            label: 'Cantidad de productos',
                            backgroundColor: '#e3f2fd',
                            borderColor: '#64b5f6',
                            borderWidth: 2,
                            data: dataBody,
                            fill: false,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    title: {
                        display: true,
                        text: 'Ranking de productos más vendidos'
                    }
                }
            });
        },
        // llamar a la lista
        showCustomers: function (e) {
            var self = this;
            if (self.content.length === 0 ) {
                instance.web.notification.do_warn("Atención","Sin datos");
                return
            }
            var hoy = moment().format('YYYY-MM-DD');
            var product_id = _.map(self.content,function(map){
                return map.id;
            })
            this.do_action({
                name: "Listado de productos más comprados",
                type: 'ir.actions.act_window',
                res_model: "product.product",
                views: [[false,'list'],[self.modelId[1],'form']],
                target: 'current',
                domain: [['id', 'in', product_id]],
                context: {},
            });
        }
    });
}
