function report_bank_gral (reporting){
    "use strict";

    var instance = openerp;

    reporting.ReportBankGralWidget = reporting.Base.extend({
        template: 'ReportBankGral',
        content:[],
        ResBank:[],
        BankPaymentLine:[],
        BankPayment:[],
        rowsData :[],
        events:{
            'click #toolbar > button' : 'clickOnAction',

            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',

            'click #Y' : 'factSearch',
            'click #current-bank' : 'factSearch',
            'click #bankPaymentsType' : 'factSearch',

            'click #W' : 'factSearch',
            'click #available' : 'factSearch',
            'click #cashed' : 'factSearch',
            'click #negotiated' : 'factSearch',
            'click #renegotiated' : 'factSearch',

            'change #from' : 'factSearch',
            'change #to' : 'factSearch',

            'click-row.bs.table #table ' : 'clickAnalysisDetail',
        },
        init : function(parent){
            this._super(parent);
        },
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },
        clickAnalysisDetail: function(e, row, $element, field){
            if (field == 'create_date'){
                this.do_action({
                    name:"Detalles del Movimiento",
                    type: 'ir.actions.act_window',
                    res_model: "res.bank.payments",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.id,
                });
            }
            if (field == 'bank'){
                this.do_action({
                    name:"Registro Banco",
                    type: 'ir.actions.act_window',
                    res_model: "res.bank",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.bank_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.bank_id,
                });
            }
            e.stopImmediatePropagation();
        },
        submitForm: function () {
            var self = this;
            self.fetchBankPayment().then(function(BankPayment) {
                return BankPayment;
            }).then(function (BankPayment) {
                self.BankPayment = BankPayment;
                return self.fetchBankPaymentLine();
            }).then(function (BankPaymentLine) {
                self.BankPaymentLine = BankPaymentLine;
                // console.log(self.BankPaymentLine);
            //     return self.fecthResBank();
            // }).then(function(ResBank){
            //     self.ResBank = ResBank;
            //     self.$el.find('#current-bank').append('<option value="9999999">Todas los bancos</option>');
            //     _.each(ResBank,function(item){
            //         self.$el.find('#current-bank').append('<option value="' + item.id + '">' + item.name + '</option>');
            //     });
            //     return self.fetchResBankPaymentsType();
            // }).then(function(BankPaymentsType){
            //     self.BankPaymentsType = BankPaymentsType;
            //     self.$el.find('#current-bank-type').append('<option value="9999999">Todas los tipos</option>');
            //     _.each(BankPaymentsType,function(item){
            //         self.$el.find('#current-bank-type').append('<option value="' + item.id + '">' + item.name + '</option>');
            //     });
            //     return self.fetchResPartner();
            // }).then(function(ResPartner){
            //     self.ResPartner = ResPartner;
                self.search();
                // self.searchBank();
                // self.searchBankPaymentsType();
                return self.BuildTable();
            });
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });

            function getDate( element ) {
                var fechaSel = element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },

        fetchBankPayment: function () {
            var self = this;
            var defer = $.Deferred();
            var field = ['id', 'create_date', 'number', 'name_holder', 'state', 'number_cta', 'currency_id', 'bank_id','date','partner_id','payments_line','amount_total','bank_payments_type_id'];
            var BankPayment = new instance.web.Model('res.bank.payments');
            BankPayment.query(field).filter().all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        fetchBankPaymentLine: function () {
            var self = this;
            var defer = $.Deferred();
            var linesIds = _.flatten(_.map(self.BankPayment, function (item) {
                console.log(linesIds);
                return item.payments_line;
            }));

            var fields = ['id', 'date', 'bank_payments_id', 'amount'];
            var domain = [['id', 'in', linesIds]];
            var BankPaymentLine = new instance.web.Model('res.bank.payments.line');
            BankPaymentLine.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },

        //Obtener la Detalles de la Factura
        getBankPayment: function (id_line){
            return _.find(this.BankPayment, function (inv) {
                return _.contains(inv.payments_line, id_line);
            });
        },

        // getBankPayment: function(id){
        //     var self = this;
        //     return _.filter(self.BankPayment,function (item) {
        //         return item.id == id;
        //     });
        // },

        // fecthResBank: function() {
        //     var self = this;
        //     var defer = $.Deferred();
        //     var ResBank = new instance.web.Model('res.bank');
        //     ResBank.query(['id', 'name', 'ruc', 'active']).filter([['active', '=', true]]).all().then(function (results) {
        //         defer.resolve(results);
        //     });
        //     return defer;
        // },
        //
        // searchBank: function () {
        //     var self = this;
        //     var results = self.ResBank;
        //     results = _.map(results, function (item) {
        //         return {
        //                 label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
        //                 value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
        //         }
        //     });
        //     self.$('#bank').autocomplete({
        //         source: results,
        //         minLength:0,
        //         search: function(event, ui) {
        //             if (!(self.$('#bank').val())){
        //                 self.factSearch();
        //             }
        //         },
        //         close: function( event, ui ) {
        //                 self.factSearch();
        //         },
        //         select: function(event, ui) {
        //             self.factSearch();
        //         }
        //     });
        // },
        //
        // fetchResBankPaymentsType: function() {
        //     var self = this;
        //     var defer = $.Deferred();
        //     var ResBankPaymentsType = new instance.web.Model('res.bank.payments.type');
        //     ResBankPaymentsType.query(['id', 'name', 'code', 'is_receipt', 'is_payment']).filter().all().then(function (results) {
        //         defer.resolve(results);
        //     });
        //     return defer;
        // },
        //
        // searchBankPaymentsType: function () {
        //     var self = this;
        //     var results = self.ResBankPaymentsType;
        //     results = _.map(results, function (item) {
        //         return {
        //                 label: item.id + '-'+ item.name + ' ' + self.valorNull(item.code),
        //                 value: item.id + '-'+ item.name + ' ' + self.valorNull(item.code)
        //         }
        //     });
        //     self.$('#bankPaymentsType').autocomplete({
        //         source: results,
        //         minLength:0,
        //         search: function(event, ui) {
        //             if (!(self.$('#bankPaymentsType').val())){
        //                 self.factSearch();
        //             }
        //         },
        //         close: function( event, ui ) {
        //                 self.factSearch();
        //         },
        //         select: function(event, ui) {
        //             self.factSearch();
        //         }
        //     });
        // },
        //
        // fetchResPartner: function() {
        //     var self = this;
        //     var defer = $.Deferred();
        //     var ResPartner = new instance.web.Model('res.partner');
        //     ResPartner.query(['id', 'name', 'ruc', 'active']).filter([['active', '=', true]]).all().then(function (results) {
        //         defer.resolve(results);
        //     });
        //     return defer;
        // },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        // search: function () {
        //     var self = this;
        //     var results = self.ResPartner;
        //     results = _.map(results, function (item) {
        //         return {
        //                 label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
        //                 value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
        //         }
        //     });
        //     self.$('#partner').autocomplete({
        //         source: results,
        //         minLength:0,
        //         search: function(event, ui) {
        //             if (!(self.$('#partner').val())){
        //                 self.factSearch();
        //             }
        //         },
        //         close: function( event, ui ) {
        //                 self.factSearch();
        //         },
        //         select: function(event, ui) {
        //             self.factSearch();
        //         }
        //     });
        // },

        BuildTable: function(){
            var self = this;
            var data = [];
            var payment;
            var item;
            var BankPayment;
            var amount_total_num;
            for (var i = 0; i < this.BankPaymentLine.length; i++) {
                item = this.BankPaymentLine[i];
                // payment = this.getBankPayment(item.id);
                    data.push({
                        // id : payment.id,
                        // number: payment.number,
                        // titular: payment.name_holder,
                        // partner: payment.partner_id[1],
                        create_date: moment(item.date).format("DD/MM/YYYY"),
                        // number_cta: payment.number_cta,
                        amount_total: accounting.formatNumber(item.amount,0,".",","),
                        // type_bank: payment.bank_payments_type_id[1],
                        // bank: payment.bank_id[1],
                        // state: payment.state,
                        date: item.date,
                        // partner_id : payment.partner_id[0],
                        // bank_id : payment.bank_id[0],
                        // bank_payments_type_id: payment.bank_payments_type_id[0],
                        amount_total_num: item.amount,
                    });
            }
            self.content = data;
            this.loadTable(data);
        },

        factSearch: function(){
            var self = this;
            var hoy = moment().format('YYYY-MM-DD');
            var desde = this.$el.find('#from').val();
            var hasta = this.$el.find('#to').val();
            var partner = this.$el.find('#partner').val().split('-');

            var bank = this.$el.find('#current-bank').val().split('-');
            var bankPaymentsType = this.$el.find('#bankPaymentsType').val();
            var content = self.content;

            if ($('#A').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.date == hoy;
                });
            }
            if ($('#B').is(":checked")){
                var date = hoy.split('-');
                var ayer = date[2] - 1;
                date.splice(2,0);
                if(date[2] < 10){
                    date[2] = '0'+ayer;
                }else{
                    date[2] = ayer;
                }
                content = _.filter(content, function (inv){
                    return inv.date == date[0]+'-'+date[1]+'-'+date[2];
                });
            }
            if ($('#C').is(":checked")){
                var date = hoy.split('-');
                content = _.filter(content, function (inv){
                    var mes = inv.date.split('-');
                    return mes[0]+'-'+mes[1] == date[0]+'-'+date[1];
                });
            }
            if ($('#D').is(":checked")){
                var date = hoy.split('-');
                var mes = date[1] - 1;
                var year;
                date.splice(1,0);
                if(date[1] == 1){
                    date[1] = '12';
                    year = date[0] - 1;
                    date[0] = year;
                }else{

                    if(date[1] < 10){
                        date[1] = '0'+mes;
                    }else{
                        date[1] = mes;
                    }
                }
                content = _.filter(content, function (inv){
                    var mes = inv.date.split('-');
                    return mes[0]+'-'+mes[1] == date[0]+'-'+date[1];
                });
            }
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date= desde.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }

            if (partner != ""){
                content = _.filter(content, function(inv){
                    return inv.partner_id == partner[0];
                });
            }
            if ($('#available').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.state == 'available';
                });
            }
            if ($('#cashed').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.state == 'cashed';
                });
            }
            if ($('#negotiated').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.state == 'negotiated';
                });
            }
            if ($('#renegotiated').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.state == 'renegotiated';
                });
            }
            if(bank != 9999999){
                content=_.filter(content, function (inv){
                    return inv.bank_id == bank[0];
                });
            }

            var amount_egress_num = _.reduce(_.map(content,function(map){
                return(map.amount_payment_num);
            }),function(memo, num){
                return memo + num;
            },0);

            var amount_to_receive_num = _.reduce(_.map(content,function(map){
                return(map.amount_receipt_num);
            }),function(memo, num){
                return memo + num;
            },0);

            var amount_entry_num = _.reduce(_.map(content,function(map){
                return(map.amount_total_num);
            }),function(memo, num){
                return memo + num;
            },0);

            content.push({
                create_date: "Totales",
                amount_payment: accounting.formatNumber(amount_egress_num,0,".",","),
                amount_receipt: accounting.formatNumber(amount_to_receive_num,0,".",","),
                amount_total: accounting.formatNumber(amount_entry_num,0,".",","),
            });

            self.loadTable(content)
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },

        getObjectPdf: function(rowsTable){
            var self = this;
            var rowsPdf=[];
            var rows=[];
            var rows = self.rowsData;
            return rows;
        },

        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjectPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                            getColumns.push([{
                                        title: item.title,
                                        dataKey: item.field
                                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
        },

        drawPDF: function (getColumns,rows) {
            var self = this;
            var hoy = moment().format('DD/MM/YYYY');
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF('l');

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    number : {columnWidth: '8px'},
                    create_date : {columnWidth: '8px'},
                    titular : {columnWidth: '8px'},
                    number_cta : {columnWidth: '6px'},
                    type_bank : {columnWidth: '6px'},
                    amount_payment: {halign:'right',columnWidth: '8px'},
                    amount_receipt: {halign:'right',columnWidth: '8px'},
                    amount_total: {halign:'right',columnWidth: '8px'},
                    date_maturity: {halign:'right',columnWidth: '8px'},
                    bank_id: {halign:'right',columnWidth: '8px'},
                    state: {halign:'right',columnWidth: '8px'}
                },
                margin: { top: 20, horizontal: 7},

                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Seguimiento de Cheque', 80, 10);

                    if(desde.length > 0 || hasta.length > 0){
                        var fecha='';
                        if(desde){
                            fecha=fecha.concat(' Desde '+desde);
                        }
                        if (hasta){
                            fecha=fecha.concat(' Hasta '+hasta);
                        }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }

                    var str = " Pagina  " + data.pageCount;
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(175,pdfDoc.internal.pageSize.height - 5,str);
                    }
            });
            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Seguimiento de Cheque.pdf')
        },
    });
}
