function report_contratocliente(reporting){
    "use strict";

    var instance = openerp;

    reporting.ReportContratoClienteWidget = reporting.Base.extend({
        template:'ReportContratoCliente',
        ContratoCliente: [],
        content:[],
        rowsData :[],
        modules:[],
        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #cerrado' : 'factSearch',
            'click #abierto' : 'factSearch',
            'click #cancelado' : 'factSearch',
            'click #pendiente' : 'factSearch',
            'click #Z' : 'factSearch',

            'click #Y' : 'factSearch',
            'click #customer' : 'factSearch',
            'change #from' : 'factSearch',
            'change #to' : 'factSearch',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
        },
        init : function(parent){
            this._super(parent);
        },
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },

        // Redirecionar
        renderReport: function () {
            var self = this;

            var container = this.$el.closest('.oe_form_sheet.oe_form_sheet_width');
            this.$el.closest('.report_view').remove();
            container.find('.report_view').show({
                effect: 'fade',
                duration: 200,
            });
        },
        // Verificar el modelo
        checkModel : function(model){
            var self = this;
            return _.filter(self.modules,function(item){return item.name === model});
        },
        // Lanzar el mensaje
        showMensaje : function(modelos){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html('Reporte in-disponible, contacte con el administrador del sistema ref : '+modelos);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                        self.renderReport()
                    }
                }
            });
            return
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        clickAnalysisDetail: function(e, row, $element, field){
            if (field == 'code'){
                this.do_action({
                    name:"Contrato",
                    type: 'ir.actions.act_window',
                    res_model: "account.analytic.account",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.id,
                });
            }
            if (field === 'partner'){
                this.do_action({
                    name:"Registro",
                    type: 'ir.actions.act_window',
                    res_model: "res.partner",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.partner_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.partner_id,
                });
            }

             e.stopImmediatePropagation();
        },

        submitForm: function () {
            var self = this;
            self.fecthIrModuleModule().then(function(modules){
                self.modules = modules;
                return modules;
            }).then(function(modules){
                return self.fetchContrato();
            }).then(function (ContratoCliente) {
                self.ContratoCliente = ContratoCliente;
                return self.fetchResPartner();
            }).then(function(ResPartner){
                self.ResPartner = ResPartner;
                self.search();
                return self.BuildTable();
            });
        },

        // Modelos instalados
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed']];
            var irModule = new instance.web.Model('ir.module.module');

            irModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });

            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },

        fetchContrato: function () {
            var self = this;
            var defer = $.Deferred();
            // var modules = self.checkModel('crm');
            //
            // if (modules.length <= 0){
            //     self.showMensaje('crm');
            //     return defer;
            // }
            var filter = [['type','=','contract']];
            var ContratoCliente = new instance.web.Model('account.analytic.account');
            ContratoCliente.query(['id', 'create_date', 'code','partner_id', 'name', 'date_start', 'recurring_total_amount', 'remaining_total', 'date', 'state','type']).filter(filter).all().then(function(results){
                defer.resolve(results);
            });

            return defer;
        },

        fetchResPartner: function () {
            var self = this;
            var defer = $.Deferred();
            var ResPartner = new instance.web.Model('res.partner');
            ResPartner.query(['id','name','ruc']).filter([['active', '=', true],['customer', '=', true]]).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        getContratoCliente: function (id) {
            var self = this;
            return _.filter(self.ContratoCliente,function (item) {
                return item.id == id;
            });
        },

        search: function () {
            var self = this;
            var results = self.ResPartner;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
                        value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
                }
            });
            self.$('#partner').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#partner').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },

        BuildTable: function(){
            var self = this;
            var ContratoCliente = self.ContratoCliente;
            var invoice;
            var state;
            var data = [];
            var crm_type;

            _.each(ContratoCliente, function(item){
                if(item.state=='close'){
                    state = 'Cerrado'
                }else
                    {
                    if(item.state=='open'){
                        state = 'En curso'
                    }else{
                        if(item.state=='cancelled'){
                            state = 'Cancelado'
                        }else{
                            state = 'Pendiente'
                        }
                    }
                }

                invoice = self.getContratoCliente(item.id).shift();
                data.push({
                  id : item.id,
                  code : self.valorNull(item.code),
                  create_date: moment(item.create_date).format("DD/MM/YYYY"),
                  name : self.valorNull(item.name),
                  partner: item.partner_id[1],
                  date_start: moment(item.date_start).format("DD/MM/YYYY"),
                  date_fin: moment(item.date).format("DD/MM/YYYY"),
                  date: moment(item.create_date).format("YYYY-MM-DD"),
                  amount_invoiced: accounting.formatNumber(item.recurring_total_amount,0,".",","),
                  amount_tot: item.recurring_total_amount,
                  state: state,
                  partner_id : item.partner_id[0]
                });
            });
            self.content = data;
            this.loadTable(data);
        },

        factSearch: function(){
            var self = this;
            var today = moment().format('YYYY-MM-DD');
            var yesterday = moment().add(-1, 'days').format('YYYY-MM-DD');
            var month = moment().format('YYYY-MM');
            var last_month = moment().add(-1, 'months').format('YYYY-MM');
            var desde = this.$el.find('#from').val();
            var hasta = this.$el.find('#to').val();
            var partner= this.$el.find('#partner').val().split('-');
            var content = self.content;

            if ($('#A').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM-DD') == today;
                });
            }
            if ($('#B').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM-DD') == yesterday;
                });
            }
            if ($('#C').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM') == month;
                });
            }
            if ($('#D').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM') == last_month;
                });
            }
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date= desde.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }

            if ($('#cerrado').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.state == 'Cerrado';
                });
            }
            if ($('#abierto').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.state == 'En curso';
                });
            }
            if ($('#cancelado').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.state == 'Cancelado';
                });
            }
            if ($('#pendiente').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.state == 'Pendiente';
                });
            }

             if (partner != ""){
                 content = _.filter(content, function(inv){
                     return inv.partner_id == partner[0];
                 });
             }

             var amount_invoiced_tot = _.reduce(_.map(content,function(map){
                 return(map.amount_tot);
             }),function(memo, num){
                 return memo + num;
             },0);

             content.push({
                 code: "Total",
                 amount_invoiced: accounting.formatNumber(amount_invoiced_tot,0,".",","),
             });

             self.loadTable(content)
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },

        getObjetPdf: function(rowsTable){
             var self = this;
             var rowsPdf=[];
             var rows=[];
             var rows = self.rowsData;
             return rows;
        },

        clickOnAction: function (e) {
             var self = this;
             var rowsNew;
             var action = self.$el.find(e.target).val();
             var table = self.$el.find("#table");
             var data2 = table.bootstrapTable('getVisibleColumns');
             var getColumns=[];
             var rows=[];
             rowsNew = self.getObjetPdf();
             if (action === 'pdf') {
                 var dataNEW = _.map(data2, function (val){
                     return val.field;
                 });
                 _.each(rowsNew,function (item){
                     rows.push(_.pick(item, dataNEW));
                 });
                 // Obtener los nombre de la Cabecera
                 _.each(_.map(data2,function(val){
                         return val;
                     }), function(item){
                             getColumns.push([{
                                         title: item.title,
                                         dataKey: item.field
                                     }]);
                 });
                 this.drawPDF(_.flatten(getColumns),rows);
             }
        },

        drawPDF: function (getColumns,rows) {
            var self = this;
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                  code : {columnWidth: '8px'},
                  date_create : {columnWidth: '8px'},
                  partner : {columnWidth: '8px'},
                  name : {columnWidth: '8px'},
                  date_start: {columnWidth: '7px'},
                  date_fin: {columnWidth: '7px'},
                  amount_invoiced: {columnWidth: '7px'},
                  state : {columnWidth: '8px'}
                },
                margin: { top: 16, horizontal: 7},

                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Analisis de contrato de clientes ', data.settings.margin.left, 10);
                    // var tipo = '';
                    //
                    // if ($('#lead').is(":checked")){
                    //     tipo = tipo.concat(' Tipo de CRM : Iniciativas' );
                    // }
                    // if ($('#opportunity').is(":checked")){
                    //     tipo = tipo.concat(' Tipo de CRM : Oportunidades' );
                    // }

                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(6,14,tipo);

                    if(desde.length > 0 || hasta.length > 0){
                        var fecha='';
                        if(desde){
                            fecha=fecha.concat(' Desde '+desde);
                        }
                        if (hasta){
                            fecha=fecha.concat(' Hasta '+hasta);
                        }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                    }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Analisis de contrato de clientes.pdf')
        },
    });
}
