function report_mrp(reporting){
    "use strict";

    var instance = openerp;

    reporting.ReportMrpWidget = reporting.Base.extend({
        template:'ReportMrp',
        Mrp: [],
        content:[],
        productProduct: [],
        rowsData :[],
        modules:[],
        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',

            'click #done' : 'factSearch',
            'click #in_production' : 'factSearch',

            'click #W' : 'factSearch',
            'click #Y' : 'factSearch',
            'click #product' : 'factSearch',

            'change #from' : 'factSearch',
            'change #to' : 'factSearch',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
        },
        init : function(parent){
            this._super(parent);
        },
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },

        // Redirecionar
        renderReport: function () {
            var self = this;

            var container = this.$el.closest('.oe_form_sheet.oe_form_sheet_width');
            this.$el.closest('.report_view').remove();
            container.find('.report_view').show({
                effect: 'fade',
                duration: 200,
            });
        },
        // Verificar el modelo
        checkModel : function(model){
            var self = this;
            return _.filter(self.modules,function(item){return item.name === model});
        },
        // Lanzar el mensaje
        showMensaje : function(modelos){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html('Reporte in-disponible, contacte con el administrador del sistema ref : '+modelos);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                        self.renderReport()
                    }
                }
            });
            return
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        clickAnalysisDetail: function(e, row, $element, field){
            if (field == 'name'){
                 this.do_action({
                     name:"Producción",
                     type: 'ir.actions.act_window',
                     res_model: "mrp.production",
                     views: [[false,'form']],
                     target: 'new',
                     domain: [['id','=', row.id]],
                     context: {},
                     flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                     res_id: row.id,
                 });
            }
            if (field === 'product'){
                this.do_action({
                    name:"Registro",
                    type: 'ir.actions.act_window',
                    res_model: "product.product",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.product_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.product_id,
                });
            }

             e.stopImmediatePropagation();
        },

        submitForm: function () {
            var self = this;
            self.fecthIrModuleModule().then(function(modules){
                self.modules = modules;
                return modules;
            }).then(function(modules){
                return self.fetchMrp();
            }).then(function(Mrp) {
                self.Mrp = Mrp;
                return self.fetchProduct();
            }).then(function(productProduct){
                self.productProduct = productProduct;
                self.search();
                return self.BuildTable();
            });
        },

        // Modelos instalados
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed']];
            var irModule = new instance.web.Model('ir.module.module');

            irModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
                .datepicker({
                    dateFormat: "dd/mm/yy",
                    changeMonth: true,
                    numberOfMonths: 1,
                })
                .on( "change", function() {
                    to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
                });
                to = $( "#to" ).datepicker({
                    dateFormat: "dd/mm/yy",
                    defaultDate: "+7d",
                    changeMonth: true,
                    numberOfMonths: 1,
                })
                .on( "change", function() {
                    from.datepicker( "option", "maxDate", getDate(this));
                });

                    function getDate( element ) {
                        var fechaSel =element.value.split('/');
                        var date;
                        try {
                            date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                        } catch( error ) {
                            date = null;
                        }
                        return date;
                    }
                },

                fetchMrp: function () {
                    var self = this;
                    var defer = $.Deferred();
                    var modules = self.checkModel('mrp');

                    if (modules.length <= 0){
                        self.showMensaje('mrp');
                        return defer;
                    }
                    var filter = [['state','in',['in_production','done']]];
                    var Mrp = new instance.web.Model('mrp.production');
                    Mrp.query(['id', 'name', 'product_id', 'date_planned', 'product_qty', 'create_date', 'state','move_created_ids2']).filter(filter).all().then(function(results){
                        defer.resolve(results);
                    });

                    return defer;
                },

                // ProductProduct
                fetchProduct: function() {
                    var self = this;
                    var defer = $.Deferred();
                    var productProduct = new instance.web.Model('product.product');
                    productProduct.query(['id','name','name_template']).filter([['active', '=', true]]).all().then(function (results) {
                        defer.resolve(results);
                    });
                    return defer;
                },
                valorNull:function(dato){
                    var valor ="";
                    if (dato){
                        valor=dato;
                    }
                    return valor;
                },
                search: function () {
                    var self = this;
                    var results = self.productProduct;
                    results = _.map(results, function (item) {
                        return {
                                label: item.id + '-'+ item.name,
                                value: item.id + '-'+ item.name
                        }
                    });
                    self.$('#product').autocomplete({
                        source: results,
                        minLength:0,
                        search: function(event, ui) {
                            if (!(self.$('#product').val())){
                                self.factSearch();
                            }
                        },
                        close: function( event, ui ) {
                                self.factSearch();
                        },
                        select: function(event, ui) {
                            self.factSearch();
                        }
                    });
                },

                BuildTable: function(){
                    var self = this;
                    var Mrp = self.Mrp;
                    var invoice;
                    var stage;
                    var qty_produced=0;
                    var qty_toproduced=0;
                    var data = [];

                    _.each(Mrp, function(item){

                        if(item.state=='in_production'){
                            stage = 'En Producción'
                            qty_toproduced=item.product_qty
                            qty_produced=0
                        }else{
                            stage = 'Realizado'
                            qty_produced=item.product_qty
                            qty_toproduced=0
                        }

                        data.push({
                            id : item.id,
                            name : item.name,
                            product: self.valorNull(item.product_id[1]),
                            create_date: moment(item.create_date).format("DD/MM/YYYY"),
                            date: moment(item.create_date).format("YYYY-MM-DD"),
                            product_qty: accounting.formatNumber(self.valorNull(qty_toproduced),2, ".", ","),
                            qty_produced: accounting.formatNumber(self.valorNull(qty_produced),2, ".", ","),
                            state: stage,
                            date_planned: moment(item.date_planned).format("DD/MM/YYYY"),
                            product_id : item.product_id[0]
                        });
                    });
                    self.content = data;
                    this.loadTable(data);
                },

                 factSearch: function(){
                     var self = this;
                     var today = moment().format('YYYY-MM-DD');
                     var yesterday = moment().add(-1, 'days').format('YYYY-MM-DD');
                     var month = moment().format('YYYY-MM');
                     var last_month = moment().add(-1, 'months').format('YYYY-MM');
                     var desde = this.$el.find('#from').val();
                     var hasta = this.$el.find('#to').val();
                     var product= this.$el.find('#product').val();
                     var content = self.content;

                     if ($('#A').is(":checked")){
                         content = _.filter(content, function (inv){
                             return moment(inv.date).format('YYYY-MM-DD') == today;
                         });
                     }
                     if ($('#B').is(":checked")){
                         content = _.filter(content, function (inv){
                             return moment(inv.date).format('YYYY-MM-DD') == yesterday;
                         });
                     }
                     if ($('#C').is(":checked")){
                         content = _.filter(content, function (inv){
                             return moment(inv.date).format('YYYY-MM') == month;
                         });
                     }
                     if ($('#D').is(":checked")){
                         content = _.filter(content, function (inv){
                             return moment(inv.date).format('YYYY-MM') == last_month;
                         });
                     }
                     if ($('#Z').is(":checked")){
                         $('#datepicker').css('display','block');
                         if (desde.length > 0){
                             var date= desde.split('/');
                             content = _.filter(content, function (inv){
                                 return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                             });
                         }
                         if (hasta.length > 0){
                             var date= hasta.split('/');
                             content = _.filter(content, function (inv){
                                 return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                             });
                         }
                     }else{
                         $('#datepicker').css('display','none');
                     }


                     if ($('#in_production').is(":checked")){
                         content = _.filter(content, function (inv){
                             return inv.state == 'En Producción';
                         });
                     }
                     if ($('#done').is(":checked")){
                         content = _.filter(content, function (inv){
                             return inv.state == 'Realizado';
                         });
                     }

                     // if (product != ""){
                     //     content = _.filter(content, function(inv){
                     //         return inv.id == product[0];
                     //     });
                     // }
                     self.loadTable(content)
                },

                loadTable:function(rowsTable){
                    var self = this;
                    self.rowsData = rowsTable;
                    var table = this.$el.find('#table');
                    table.bootstrapTable('load',rowsTable);
                },

                getObjetPdf: function(rowsTable){
                     var self = this;
                     var rowsPdf=[];
                     var rows=[];
                     var rows = self.rowsData;
                     return rows;
                },

                clickOnAction: function (e) {
                     var self = this;
                     var rowsNew;
                     var action = self.$el.find(e.target).val();
                     var table = self.$el.find("#table");
                     var data2 = table.bootstrapTable('getVisibleColumns');
                     var getColumns=[];
                     var rows=[];
                     rowsNew = self.getObjetPdf();
                     if (action === 'pdf') {
                         var dataNEW = _.map(data2, function (val){
                             return val.field;
                         });
                         _.each(rowsNew,function (item){
                             rows.push(_.pick(item, dataNEW));
                         });
                         // Obtener los nombre de la Cabecera
                         _.each(_.map(data2,function(val){
                                 return val;
                             }), function(item){
                                     getColumns.push([{
                                                 title: item.title,
                                                 dataKey: item.field
                                             }]);
                         });
                         this.drawPDF(_.flatten(getColumns),rows);
                     }
                },

                drawPDF: function (getColumns,rows) {
                    var self = this;
                    var desde =(this.$el.find('#from').val());
                    var hasta =(this.$el.find('#to').val());
                    var totalPagesExp = "{total_pages_count_string}";
                    var pdfDoc = new jsPDF();

                    pdfDoc.autoTable(getColumns, rows, {
                        styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                        columnStyles: {
                          name : {columnWidth: '4px'},
                          product : {columnWidth: '6px'},
                          date : {columnWidth: '9px'},
                          product_qty : {columnWidth: '5px'},
                          qty_produced : {columnWidth: '5px'},
                          date_planned : {columnWidth: '7px'},
                          state : {columnWidth: '6px'}
                        },
                        margin: { top: 16, horizontal: 7},

                        addPageContent: function (data) {
                            pdfDoc.setFontSize(12);
                            pdfDoc.setFontStyle('bold');
                            pdfDoc.setTextColor(40);
                            pdfDoc.text('Histórico de Fabricación', data.settings.margin.left, 10);

                            if(desde.length > 0 || hasta.length > 0){
                                var fecha='';
                                if(desde){
                                    fecha=fecha.concat(' Desde '+desde);
                                }
                                if (hasta){
                                    fecha=fecha.concat(' Hasta '+hasta);
                                }
                                pdfDoc.setFontSize(10);
                                pdfDoc.setFontStyle('bold');
                                pdfDoc.setTextColor(40)
                                pdfDoc.text(fecha, data.settings.margin.left,14);
                            }
                            // FOOTER
                            var str = "Pagina  " + data.pageCount;
                            // Total page number plugin only available in jspdf v1.0+
                            if (typeof pdfDoc.putTotalPages === 'function') {
                                str = str + " de " + totalPagesExp;
                            }
                            pdfDoc.setFontSize(9);
                            pdfDoc.setFontStyle('bold');
                            pdfDoc.setTextColor(40);
                            pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                            }
                    });

                    if (typeof pdfDoc.putTotalPages === 'function') {
                        pdfDoc.putTotalPages(totalPagesExp);
                    }
                    pdfDoc.save('Histórico de fabricacion.pdf')
                },
            });
        }
