function report_product_pack (reporting) {
    "use strict";

    var instance = openerp;

    reporting.ReportProductPackWidget = reporting.Base.extend({
        template: 'ReportProductPack',
        data: [],
        PosOrderLine: [],
        PosOrder: [],
        invoiceLine: [],
        productProduct: [],
        productPack: [],
        productAtributo: [],
        ranking: [],
        content: [],
        modelId: [],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',

            'click #Y' : 'factSearch',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.submitForm();
        },

        // Redirecionar
        renderReport: function () {
            var self = this;

            var container = this.$el.closest('.oe_form_sheet.oe_form_sheet_width');
            this.$el.closest('.report_view').remove();
            container.find('.report_view').show({
                effect: 'fade',
                duration: 200,
            });
        },
        // Verificar el modelo
        checkModel : function(model){
            var self = this;
            return _.filter(self.modules,function(item){return item.name === model});
        },

        // Lanzar el mensaje
        showMensaje : function(modelos){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html('Reporte in-disponible, contacte con el administrador del sistema ref : '+modelos);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                        self.renderReport()
                    }
                }
            });
            return
        },

        // Analisis Detallado
        clickAnalysisDetail: function(e, row, $element, field){

            if (field == 'product_main'){
                this.do_action({
                    name : "Registro de Producto",
                    type : 'ir.actions.act_window',
                    res_model : "product.product",
                    views : [[false,'form']],
                    target : 'new',
                    domain : [['id','=', row.product_main_id]],
                    context : {},
                    flags : {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id : row.product_main_id,
                });
            }

            e.stopImmediatePropagation();
        },

        submitForm: function () {
            var self = this;
            self.fecthIrModuleModule().then(function(modules){
                self.modules = modules;
                return modules;
            }).then(function(modules){
                return self.fecthProductProduct();
            }).then(function(productProduct){
                self.productProduct = productProduct;
                return self.fetchProductPack();
            }).then(function(productPack){
                self.productPack = productPack;
                self.search();
                return self.BuildTable();
            });
        },

        // Modelos instalados
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed']];
            var irModule = new instance.web.Model('ir.module.module');
            irModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        // Obtener Productos
        fecthProductProduct: function() {
            var self = this;
            var defer = $.Deferred();
            var modules = self.checkModel('product_pack');

            if (modules.length <= 0){
                self.showMensaje('product_pack');
                return defer;
            }

            var fields = ['id', 'name','name_template', 'pack_line_ids','type', 'ean13','attribute_str'];
            var domain = [['active', '=', true],['pack', '=', true]];
            var ProductProduct = new instance.web.Model('product.product');
            ProductProduct.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        // Product Pack
        fetchProductPack: function(){
            var self = this;
            var defer = $.Deferred();
            var ids = _.flatten(_.map(self.productProduct,function (item) {
                return item.id;
            }));
            var fields = ['id','product_id', 'price','parent_product_id', 'quantity', 'subtotal'];
            var domain = [['parent_product_id', 'in', ids]];
            var ProductPack =  new instance.web.Model('product.pack.line');
            ProductPack.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        getProductPack: function(id){
            var self = this;
            return _.filter(self.productPack,function (item) {
                return item.parent_product_id[0] == id;
            });
        },

        search: function () {
            var self = this;
            var results = self.productProduct;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '- '+ ' [ ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) ' ,
                        value: item.id + '- '+ ' [ ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) '
                }
            });
            self.$('#product').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#product').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },

        // Generar el ranking
        BuildTable: function() {
            var self = this;
            var ProductProduct = self.productProduct;
            var itemProduct;
            var itemLine;
            var itemProductPack;
            var itemPack;
            var qty = 0;
            var rankingItem = [];
            var rankingCab = [];
            var cat = 0;
            var countPack = 0;
            var attribute;

            _.each(ProductProduct, function(item){

                if(item.attribute_str){
                    attribute = ' ' + item.attribute_str;
                }else{
                    attribute = ' ';
                }
                itemProductPack = self.getProductPack(item.id);

                rankingItem.push({
                    product_main: item.name_template + attribute,
                    product: "",
                    qty: "",
                    countPack: "",
                    product_main_id: item.id
                });

                for (var i = 0; i < itemProductPack.length; i++) {


                    if (itemProductPack.length > 0){
                        rankingItem.push({
                            product_main: "",
                            product: itemProductPack[i].product_id[1],
                            qty: accounting.formatNumber(itemProductPack[i].quantity,3,".",","),
                            countPack: itemProductPack[i].quantity,
                            product_main_id: itemProductPack[i].parent_product_id[0],
                        })
                    }
                }


                // Generar Objeto Principal
                rankingItem=rankingItem.concat(rankingCab);

            });

            self.content = rankingItem;
            self.loadTable(rankingItem);

        },

        factSearch: function(){
            var self = this;
            var product = this.$el.find('#product').val().split('-');

            var content = self.content;


            if (product != ""){
                content = _.filter(content, function(inv){
                    return inv.product_main_id == product[0];
                    //return inv.product_main_id == product;
                });
            }

            self.loadTable(content)
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },

        getObjetPdf: function(rowsTable){
            var self = this;
            var rows=self.rowsData;

            return rows;
        },

        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjetPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                            getColumns.push([{
                                        title: item.title,
                                        dataKey: item.field
                                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
        },
        drawPDF: function (getColumns,rows) {
            var self = this;
            var fechaActu= new Date();
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new window.jsPDF();

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    product_main : {columnWidth: '6px'},
                    product : {columnWidth: '8px'},
                    qty : {halign:'right',columnWidth: '6px'},
                },
                margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Listado de Receta de Pack de Producto ', data.settings.margin.left, 10);
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                    }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Listado de Receta de Pack de Producto.pdf')
        },
    });
}
