function report_ranking_purchases_orders_supplier (reporting) {
    "use strict";

    var instance = openerp;

    reporting.ReportRankingPurchasesOrdersSupplierWidget = reporting.Base.extend({
        template: 'ReportRankingPurchasesOrdersSupplier',
        data: [],
        accountInvoice: [],
        invoiceLine: [],
        ResPartner: [],
        productProduct: [],
        ranking: [],
        content: [],
        modelId: [],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',
            'click #partner' : 'factSearch',
            'click #Y' : 'factSearch',
            'change #from' : 'factSearch',
            'change #to' : 'factSearch',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
            'click canvas': 'showSuppliers',
            'click #volver_btn': 'volver',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },

        // Redirecionar
        renderReport: function () {
            var self = this;

            var container = this.$el.closest('.oe_form_sheet.oe_form_sheet_width');
            this.$el.closest('.report_view').remove();
            container.find('.report_view').show({
                effect: 'fade',
                duration: 200,
            });
        },

        // Verificar el modelo
        checkModel : function(model){
            var self = this;
            return _.filter(self.modules,function(item){return item.name === model});
        },

        // Lanzar el mensaje
        showMensaje : function(modelos){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html('Reporte in-disponible, contacte con el administrador del sistema ref : '+modelos);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                        self.renderReport()
                    }
                }
            });
            return
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });

            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },

        clickAnalysisDetail: function(e, row, $element, field){
            if (field == 'name'){
                this.do_action({
                    name:"Proveedor",
                    type: 'ir.actions.act_window',
                    res_model: "res.partner",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.id,
                });
            }
            e.stopImmediatePropagation();
        },

        submitForm: function () {
            var self = this;
            self.fecthIrModuleModule().then(function(modules){
                self.modules = modules;
                return modules;
            }).then(function(modules){
                return self.fecthPurchasesOrder();
            }).then(function (PurchasesOrder) {
                self.PurchasesOrder = PurchasesOrder;
                return self.fecthResPartner();
            }).then(function (ResPartner) {
                self.ResPartner = ResPartner;
                self.search();
                return self.BuildTable();
            });
        },

        // Modelos instalados
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed']];
            var irModule = new instance.web.Model('ir.module.module');

            irModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        // Obtener Pedido
        fecthPurchasesOrder: function() {
            var self = this;
            var defer = $.Deferred();
            var modules = self.checkModel('purchase');

            if (modules.length <= 0){
                self.showMensaje('purchase');
                return defer;
            }

            var fields = ['id','date_order','partner_id','amount_total'];
            var domain = [['state', 'in', ['done']], ['partner_id', '!=', false]];
            var PurchasesOrder = new instance.web.Model('purchase.order');
            PurchasesOrder.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        // Consultar Clientes
        fecthResPartner: function() {
            var self = this;
            var defer = $.Deferred();
            var partner_id = _.map(self.PurchasesOrder,function(map){
                return map.partner_id[0];
            });
            var fields = ['id', 'name', 'ruc'];
            var domain = [['id', 'in', partner_id]];
            var ResPartner = new instance.web.Model('res.partner');
            ResPartner.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },

        // Obtener facturas por cada clientes
        getPurchasesOrder:function(partner_id) {
            var self = this;
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var PurchasesOrder = self.PurchasesOrder;
            // Hoy
            if ($('#A').is(":checked")){
                PurchasesOrder = _.filter(PurchasesOrder, function (inv){
                    return moment(inv.date_order).format('YYYY-MM-DD') == moment().format('YYYY-MM-DD');
                });
            }
            // Ayer
            if ($('#B').is(":checked")){
                PurchasesOrder = _.filter(PurchasesOrder, function (inv){
                    return moment(inv.date_order).format('YYYY-MM-DD') == moment().add(-1,'days').format('YYYY-MM-DD');
                });
            }
            // Mes Actual
            if ($('#C').is(":checked")){
                PurchasesOrder = _.filter(PurchasesOrder, function (inv){
                    return moment(inv.date_order).format('MM') == moment().format('MM');
                });
            }
            // Mes Pasado
            if ($('#D').is(":checked")){
                PurchasesOrder = _.filter(PurchasesOrder, function (inv){
                    return moment(inv.date_order).format('MM') == moment().add(-1,'months').format('MM');
                });
            }
            // Rango de fechas
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date = desde.split('/');
                    PurchasesOrder = _.filter(PurchasesOrder, function (inv){
                        return moment(inv.date_order).format('YYYY-MM-DD') >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    PurchasesOrder = _.filter(PurchasesOrder, function (inv){
                        return moment(inv.date_order).format('YYYY-MM-DD') <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }

            return _.flatten(_.filter(PurchasesOrder,function (inv) {
                return inv.partner_id[0] === partner_id;
            }));
        },

        search: function () {
            var self = this;
            var results = self.ResPartner;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
                        value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
                }
            });
            self.$('#partner').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#partner').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },

        // Generar el Ranking
        BuildTable: function() {
            var self = this;
            var itemPartner;
            var itemPurchasesOrder;
            var countPurchasesOrder = 0;
            var quantity = 0;
            var data = [];

            for (var i = 0; i < self.ResPartner.length; i++) {
                itemPartner = self.ResPartner[i];
                itemPurchasesOrder = self.getPurchasesOrder(itemPartner.id);

                quantity = _.reduce(_.map(itemPurchasesOrder,function(item) {
                    return item.amount_total;
                }),function(memo, num) {
                    return memo + num;
                },0);

                if(quantity > 0){
                    data.push({
                        id: itemPartner.id,
                        ruc: self.valorNull(itemPartner.ruc),
                        name: itemPartner.name,
                        countPurchasesOrder: accounting.formatNumber(quantity,0,".",","),
                        qty:quantity,
                        graficar: true
                    });
                }
            }

            data.sort(function (a, b) {
                return b.qty - a.qty
            });

            self.content = data;
            self.loadTable(data);
        },

        factSearch: function(){
            var self = this;

            var partner= this.$el.find('#partner').val().split('-');
            var content = self.content;

            if (partner != ""){
                content = _.filter(content, function(inv){
                    return inv.id == partner[0];
                });
            }

            self.BuildTable();
            self.loadTable(content)
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },

        getObjetPdf: function(rowsTable){
            var self = this;
            var rows=self.rowsData;
            return rows;
        },

        // volver
        volver: function(){
            this.$el.find('#volver').empty();
            this.$el.find('#grafico').empty();
            this.$el.find('.bootstrap-table').show({
                effect: 'drop',
                direction: 'down',
                duration: 200,
            });
        },

        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjetPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                            getColumns.push([{
                                        title: item.title,
                                        dataKey: item.field
                                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
            if (action === 'chart'){
                var self = this;
                var objetChar;
                objetChar = _.filter(rowsNew,function(item){return item.graficar === true});
                self.fectCharFilter(objetChar);
            }
        },

        drawPDF: function (getColumns,rows) {
            var self = this;
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    name : {columnWidth: '10px'},
                    ruc : {columnWidth: '8px'},
                    countPurchasesOrder : {halign:'right',columnWidth: '8px'},
                },
                margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Ranking de proveedores', data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                        var fecha='';
                        if(desde){
                            fecha=fecha.concat(' Desde '+desde);
                        }
                        if (hasta){
                            fecha=fecha.concat(' Hasta '+hasta);
                        }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                    }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Ranking de proveedores.pdf')
        },
        // Char filter
        fectCharFilter: function(objetChar){
            var self = this;
            var dataBody=[];
            var dataHeader=[];
            // objetChar
            var canvas="<canvas id='graf_resume'></canvas>";
            this.$el.find('#grafico').append(canvas);
            _.each(objetChar,function(rowsNew){
                dataHeader.push(rowsNew.name);
                dataBody.push(parseFloat(((rowsNew.countPurchasesOrder.replace(".","")).replace(",","."))));
            });
            var selector ="<button type='button' class='oe_button oe_form_button oe_highlight' id='volver_btn' name='volver_btn'><span>Atras</span></button>";
            this.$el.find('#volver').append(selector);
            this.$el.find('.bootstrap-table').hide({
                    effect: 'drop',
                    direction: 'up',
                    duration: 200,
                    complete: function () {
                        self.drawChart(dataHeader,dataBody);
                    }
                });
        },

        //Chart
        drawChart: function (dataHeader,dataBody) {
            var barChart = new Chart(this.$el.find('#graf_resume'), {

                type: 'line',
                data: {
                    labels: dataHeader,
                    datasets: [
                        {
                            label: 'Total de Compra',
                            backgroundColor: '#e3f2fd',
                            borderColor: '#64b5f6',
                            borderWidth: 2,
                            data: dataBody,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    title: {
                        display: true,
                        text: 'Ranking de proveedores a quienes más compras'
                    }
                }
            });
        },
        // llamar a la lista
        showSuppliers: function (e) {
            var self = this;
            if (self.content.length === 0 ) {
                instance.web.notification.do_warn("Atención","Sin datos");
                return
            }
            var hoy = moment().format('YYYY-MM-DD');
            var partner_id = _.map(self.content,function(map){
                return map.id;
            })
            this.do_action({
                name: "Listado de proveedores a quien más compras",
                type: 'ir.actions.act_window',
                res_model: "res.partner",
                views: [[false,'list'],[self.modelId[1],'form']],
                target: 'current',
                domain: [['id', 'in', partner_id]],
                context: {},
            });
        }
    });
}
