function report_refund_invoice_supplier (reporting){
    "use strict";

    var model = openerp;

    reporting.ReportRefundInvoiceSupplierWidget = reporting.Base.extend({
        template: 'ReportRefundInvoiceSupplier',
        invoices: [],
        invoiceLines: [],
        productProduct:[],
        Currency:[],
        rowsData :[],
        rowOrigin:[],
        accountJournal:[],
        resCompany:[],
        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',

            'click #Y' : 'factSearch',
            'click #purchase' : 'factSearch',
            'click #expense' : 'factSearch',

            'change #current-journal': 'factSearch',

            'change #from' : 'factSearch',
            'change #to': 'factSearch',
            // 'click #volver_btn': 'volver',
            'click-row.bs.table #table' : 'ckickAnalysisDetail',
        },
        init : function(parent){
          this._super(parent);
        },
        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowOrigin});
            this.fecthFecha();
            this.submitForm();
        },
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },
        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
              from = $( "#from" )
                .datepicker({
                  dateFormat: "dd/mm/yy",
                  changeMonth: true,
                  numberOfMonths: 1,
                })
                .on( "change", function() {
                  to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
                });
              to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
              })
              .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
              });

            function getDate( element ) {
              var fechaSel =element.value.split('/');
              var date;
              try {
                date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
              } catch( error ) {
               date = null;
              }
              return date;
            }
          },
        ckickAnalysisDetail: function(e, row, $element, field){
            if (field == 'name'){
                this.do_action({
                    name : "Variantes de Producto",
                    type : 'ir.actions.act_window',
                    res_model : "product.product",
                    views : [[false,'form']],
                    target : 'new',
                    domain : [['id','=', row.id_product]],
                    context : {},
                    flags : {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id : row.id_product,
                });
            }
            if (field == 'number'){
                this.do_action({
                    name : "Factura de Proveedor",
                    type : 'ir.actions.act_window',
                    res_model : "account.invoice",
                    views : [[false,'form']],
                    target : 'new',
                    domain : [['type', '=', 'in_refund'],['id','=', row.id]],
                    context : {},
                    flags : {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id : row.id,
                });
            }
            e.stopImmediatePropagation();
        },
        submitForm: function () {
            var self = this;
            this.fetchResCurrencyRate().then(function(ResCurrencyRate) {
                self.ResCurrencyRate = ResCurrencyRate;
                return ResCurrencyRate;
            }).then(function (ResCurrencyRate) {
                return self.fetchAccountJournal();
            }).then(function (AccountJournal) {
                self.AccountJournal = AccountJournal;
                self.$el.find('#current-journal').append('<option value="9999999">TODAS LAS SUC.</option>');
                _.each(AccountJournal, function (item) {
                  self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fetchAccountInvoice();
            }).then(function (AccountInvoice){
                self.AccountInvoice = AccountInvoice;
                return self.fetchAccountInvoiceLine();
            }).then(function (AccountInvoiceLine) {
                self.AccountInvoiceLine = AccountInvoiceLine;
                return self.fecthProductProduct();
            }).then(function(ProductProduct){
                self.ProductProduct = ProductProduct;
                return self.fecthResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
            return self.fetchResPartner();
            }).then(function(ResPartner){
                self.ResPartner = ResPartner;
                self.search();
                self.searchProduct();
                return self.getInvoiceCurrency();
            });
        },
        fetchResCurrencyRate: function () {
            var defer = $.Deferred();
            var fields = ['id', 'name', 'currency_id', 'rate', 'create_date'];

            var domain = [['currency_id', 'in', [166 , 20, 7, 3]]];
            var ResCurrencyRate = new model.web.Model('res.currency.rate');
            ResCurrencyRate.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchAccountJournal: function () {
            var self = this;
            var defer = $.Deferred();
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(['id', 'name']).filter([['type', '=', 'purchase'], ['active', '=', true]]).all().then(function (results) {
                defer.resolve(results);
            });
              return defer;
        },
        fetchAccountInvoice: function () {
            var filter = [['state', 'in',['open','paid']],['type', '=', 'in_refund']];
            var journal_ids = _.flatten(_.map(this.AccountJournal, function (item) {
                return item.id;
            }));
            var field =['id', 'type', 'number', 'origin', 'state', 'journal_id', 'currency_id', 'invoice_line','date_invoice','partner_id'];
            var defer = $.Deferred();
            var AccountInvoice = new model.web.Model('account.invoice');
            AccountInvoice.query(field).filter(filter).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchAccountInvoiceLine: function () {
            var self = this;
            var defer = $.Deferred();
            var linesIds = _.flatten(_.map(self.AccountInvoice, function (item) {
                return item.invoice_line;
            }));
            var InvoiceLine = new model.web.Model('account.invoice.line');
            InvoiceLine.query(['id', 'quantity', 'price_unit', 'discount', 'name', 'product_id', 'origin','invoice_id']).filter([['id', 'in', linesIds]]).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },
        fecthProductProduct: function(){
            var self = this;
            var defer = $.Deferred();
            var porductIDS = _.flatten(_.map(self.AccountInvoiceLine, function (item) {
                return item.product_id[0];
            }));
            var ProductProduct =  new model.web.Model('product.product');
            var fields = ['id','name', 'default_code', 'name_template','ean13', 'standard_price','type','attribute_str'];
            ProductProduct.query(fields).filter([['id', 'in', porductIDS]]).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },
        fecthResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id', 'currency_id'];
            var domain=[['id','=',1]];
            currency.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        fetchResPartner: function () {
            var self = this;
            var defer = $.Deferred();
            var ResPartner = new model.web.Model('res.partner');
            ResPartner.query(['id','name','ruc']).filter([['active', '=', true],['supplier', '=', true]]).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        getAccountInvoice: function (id){
            var self = this;
            return _.find(self.AccountInvoice, function (inv) {
                return _.contains(inv.invoice_line, id);
            });
        },
        getProductProduct: function(id){
            var self = this;
            return _.find(self.ProductProduct, function(item){
                return _.contains(id, item.id);
            });
        },
        getResCurrencyRate: function (id){
            var self = this;
            return _.find(self.ResCurrencyRate,function (item) {
                return _.contains(item.currency_id,id);
            });
        },
        getInvoiceCurrency: function(){
            var self = this;
            for (var i = 0; i < self.AccountInvoice.length; i++) {
                var currency_new;
                var item = self.AccountInvoice[i];
                var id = item.currency_id[0];
                currency_new = self.getResCurrencyRate(id);
                if (!currency_new){
                    currency_new={};
                    currency_new.rate=1;
                }
                self.AccountInvoice[i].rate=(currency_new.rate);
            }
            return this.BuildTable();
        },
        BuildTable: function(){
            var self = this;
            var data=[];
            var AccountInvoiceLine = self.AccountInvoiceLine
            var invoice;
            var producto;
            var invoice_type;
            _.each(AccountInvoiceLine, function(item){
                invoice = self.getAccountInvoice(item.id);
                producto =self.getProductProduct(item.product_id);
                if (!producto){
                    producto={};
                    producto.standard_price=0;
                }
                if(invoice.origin == false){
                    invoice_type = 'expense'
                }else{
                    invoice_type = 'purchase'
                }
                data.push({
                    id : invoice.id,
                    number : (invoice.number),
                    id_product : producto.id,
                    name : (item.name),
                    quantity : accounting.formatNumber((item.quantity),0, ".", ","),
                    price_unity : accounting.formatNumber((item.price_unit / invoice.rate),2, ".", ","),
                    standar_tot : accounting.formatNumber((item.quantity * item.price_unit),2, ".", ","),
                    journal_id :(invoice.journal_id[0]),
                    journal_name :(invoice.journal_id[1]),
                    date_invoice : (invoice.date_invoice),
                    partner_id : invoice.partner_id[0],
                    date_create :moment(invoice.date_invoice).format("DD/MM/YYYY"),
                    amount : (item.quantity * item.price_unit),
                    partner_name : invoice.partner_id[1],
                    invoice_type : invoice_type
                });
            });

            self.rowsData=data;
            self.rowOrigin=data;
            self.loadTable(data)
        },
        factSearch: function(){
            var self = this;
            var hoy = moment().format('YYYY-MM-DD');
            var partner = this.$el.find('#partner').val().split('-');
            var product = this.$el.find('#product').val().split('-');
            var desde =this.$el.find('#from').val();
            var hasta =this.$el.find('#to').val();
            self.rowsData=self.rowOrigin;

            if ($('#A').is(":checked")){
                self.rowsData = _.filter(self.rowsData, function (inv){
                    return inv.date_invoice == hoy;
                });
            }
            if ($('#B').is(":checked")){
                var date = hoy.split('-');
                var ayer = date[2] - 1;
                date.splice(2,0);
                date[2] = '0'+ayer;
                self.rowsData = _.filter(self.rowsData, function (inv){
                    return inv.date_invoice == date[0]+'-'+date[1]+'-'+date[2];
                });
            }
            if ($('#C').is(":checked")){
                var date = hoy.split('-');
                self.rowsData = _.filter(self.rowsData, function (inv){
                    var mes = inv.date_invoice.split('-');
                    return mes[0]+'-'+mes[1] == date[0]+'-'+date[1];
                });
            }
            if ($('#D').is(":checked")){
                var date = hoy.split('-');
                var mes = date[1] - 1;
                var year;
                date.splice(1,0);
                if(date[1] == 1){
                    date[1] = '12';
                    year = date[0] - 1;
                    date[0] = year;
                }else{

                    if(date[1] < 10){
                        date[1] = '0'+mes;
                    }else{
                        date[1] = mes;
                    }
                }
                self.rowsData = _.filter(self.rowsData, function (inv){
                    var mes = inv.date.split('-');
                    return mes[0]+'-'+mes[1] == date[0]+'-'+date[1];
                });
            }
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date= desde.split('/');
                    self.rowsData = _.filter(self.rowsData, function (inv){
                        return inv.date_invoice >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    self.rowsData = _.filter(self.rowsData, function (inv){
                        return inv.date_invoice <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }

            if ($('#purchase').is(":checked")){
                self.rowsData = _.filter(self.rowsData, function (inv){
                    return inv.invoice_type == 'purchase';
                });
            }
            if ($('#expense').is(":checked")){
                self.rowsData = _.filter(self.rowsData, function (inv){
                    return inv.invoice_type == 'expense';
                });
            }

            if (partner != ""){
                self.rowsData = _.filter(self.rowsData, function(inv){
                    return inv.partner_id == partner[0];
                });
            }
            if (product != ""){
                self.rowsData = _.filter(self.rowsData, function(inv){

                    return inv.id_product == product[0];
                });
            }

            var amount_total_total = _.reduce(_.map(self.rowsData,function(map){
                return(map.amount);
            }),function(memo, num){
                return memo + num;
            },0);

            self.rowsData.push({
                number: "Total",
                standar_tot: accounting.formatNumber((amount_total_total),2,".",","),
            });

            self.loadTable(self.rowsData);
        },
        search: function () {
            var self = this;
            var results = self.ResPartner;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
                        value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
                }
            });
            self.$('#partner').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#partner').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },
        searchProduct: function () {
            var self = this;
            var results = self.ProductProduct;
            results = _.map(results, function (item) {
                return {
                    label: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) ' ,
                    value: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) '
                }
            });
            self.$('#product').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#product').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },
        loadTable:function(rowsTable){
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },
        clickOnAction: function (e) {
            var action = this.$el.find(e.target).val();
            var self = this;
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){ return val.field});
                _.each(this.rowsData,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                _.each(_.map(data2,function(val){
                    return val}), function(item){
                    getColumns.push([{
                                    title: item.title,
                                    dataKey: item.field
                                }]);
                });
                this.drawPDF(_.flatten(getColumns),rows)
            }
        },
        drawPDF: function (getColumns,rows) {
            var self = this;
            var rowsPdf=[];
            var hoy = moment().format('DD/MM/YYYY');
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var company = _.map(self.ResCompany, function (map) {
                return map.currency_id[1];
            });

            var pdfDoc = new jsPDF();

            var quantity=_.reduce(_.map(rows,function(item){
                var valor=0;
                if (item.quantity){valor = parseFloat(((item.quantity.replace(".","")).replace(",",".")))}return valor}), function(memo, num){ return memo + num; },0);
            var price_unity=_.reduce(_.map(rows,function(item){
                var valor =0;
                if (item.price_unity){valor=parseFloat(((item.price_unity.replace(".","")).replace(",",".")))} return valor}), function(memo, num){ return memo + num; },0);
            var standar_tot=_.reduce(_.map(rows,function(item){
                var valor=0;
                if (item.standar_tot){valor=parseFloat(((item.standar_tot.replace(".","")).replace(",",".")))} return valor }), function(memo, num){ return memo + num; },0);

            rowsPdf=rows;

            rowsPdf.push({
                number : "TOTAL "+ company,
                quantity: accounting.formatNumber(quantity,0, ".", ","),
                standar_tot : accounting.formatNumber(standar_tot,2, ".", ","),
            });

            pdfDoc.autoTable(getColumns, rowsPdf, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    number: {fontStyle: 'bold'},
                    date_create :{columnWidth: '12px'},
                    partner_name :{columnWidth: '10px'},
                    name :{columnWidth: '10px'},
                    quantity :{halign:'right' },
                    price_unity : {halign:'right' },
                    standar_tot : {halign:'right' },
                },
                margin: { top: 20, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Análisis de facturas rectificativas de compras ',80,10);

                    var tipo = '';
                    if ($('#Y').is(":checked")){
                        tipo = tipo.concat(' Tipo de factura : Todas las facturas' );
                    }
                    if ($('#purchase').is(":checked")){
                        tipo = tipo.concat(' Tipo de factura : Compras' );
                    }
                    if ($('#expense').is(":checked")){
                        tipo = tipo.concat(' Tipo de factura : Gastos' );
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(6,14,tipo);

                    var fecha = '';
                    if ($('#X').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Sin Filtros' );
                    }
                    if ($('#A').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Hoy' );
                    }
                    if ($('#B').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Ayer' );
                    }
                    if ($('#C').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Mes Actual' );
                    }
                    if ($('#D').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Mes Pasado' );
                    }
                    if ($('#Z').is(":checked")){
                        if(desde.length > 0 || hasta.length > 0){
                            if(desde){
                                fecha=fecha.concat(' Desde: '+ desde);
                            }
                            if (hasta){
                                fecha=fecha.concat(' Hasta: '+ hasta);
                            }
                        }
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(6,18,fecha);

                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(150,14," Fecha de Expedición: " + hoy);



                    var str = "Pagina  " + data.pageCount;
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(175,pdfDoc.internal.pageSize.height - 5,str);
                }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Análisis de facturas rectificativas de compras.pdf')
        },
    });
}
