function report_stock_move(reporting){
    "use strict";

    var instance = openerp;

    reporting.ReportStockMoveWidget = reporting.Base.extend({
        template: 'ReportStockMove',
        content: [],
        rowsData :[],
        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'factSearch',
            'click #A' : 'factSearch',
            'click #B' : 'factSearch',
            'click #C' : 'factSearch',
            'click #D' : 'factSearch',
            'click #Z' : 'factSearch',
            'change #from' : 'factSearch',
            'change #to' : 'factSearch',
            'change #current-location-origin' : 'factSearch',
            'change #current-location-destiny' : 'factSearch',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
        },
        init : function(parent){
            this._super(parent);
        },
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },
        clickAnalysisDetail: function(e, row, $element, field){
            if (field == 'picking_name'){
                if(row.picking_id != undefined){
                    this.do_action({
                    name:"Transferencia",
                    type: 'ir.actions.act_window',
                    res_model: "stock.picking",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.picking_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.picking_id,
                    });
                }

            }
            if (field == 'product_name'){
                this.do_action({
                name:"Producto",
                type: 'ir.actions.act_window',
                res_model: "product.product",
                views: [[false,'form']],
                target: 'new',
                domain: [['id','=', row.product_id]],
                context: {},
                flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                res_id: row.product_id,
                });
            }
            if (field == 'partner_name'){
                if(row.partner_id != undefined){
                    this.do_action({
                    name:"Registro",
                    type: 'ir.actions.act_window',
                    res_model: "res.partner",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.partner_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.partner_id,
                    });
                }

            }
            e.stopImmediatePropagation();
        },
        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
            from = $( "#from" )
            .datepicker({
                dateFormat: "dd/mm/yy",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
            });
            to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
            })
            .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
            });

            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },
        submitForm: function () {
            var self = this;
            self.fetchStockMove().then(function(StockMove) {
                return StockMove;
            }).then(function (StockMove){
                self.StockMove = StockMove;
                return self.fetchResPartner();
            }).then(function(ResPartner){
                self.ResPartner=ResPartner;
                return self.fetchProductProduct();
            }).then(function(ProductProduct){
                self.ProductProduct=ProductProduct;
                return self.fetchStockLocation();
            }).then(function(StockLocation){
                self.StockLocation=StockLocation;
                self.$el.find('#current-location-origin').append('<option value="9999999">Todas las ubicaciones</option>');
                _.each(StockLocation, function (item) {
                    self.$el.find('#current-location-origin').append('<option value="' + item.id + '">'+ item.location_id[1] + " / " + item.name + '</option>');
                });
                self.$el.find('#current-location-destiny').append('<option value="9999999">Todas las ubicaciones</option>');
                _.each(StockLocation, function (item) {
                    self.$el.find('#current-location-destiny').append('<option value="' + item.id + '">'+ item.location_id[1] + " / " + item.name + '</option>');
                });
                self.search();
                self.searchProduct();
                return self.BuildTable();
            });
        },
        fetchStockMove: function () {
            var self = this;
            var defer = $.Deferred();
            var filter =[['state', '=', 'done']];
            var field =['id', 'name', 'product_id', 'product_uom_qty', 'location_id', 'location_dest_id', 'date', 'picking_id','origin','partner_id'];
            var StockMove = new instance.web.Model('stock.move');
            StockMove.query(field).filter(filter).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchResPartner: function() {
            var self = this;
            var defer = $.Deferred();
            var ResPartner = new instance.web.Model('res.partner');
            ResPartner.query(['id', 'name', 'ruc']).filter([['active', '=', true], ['customer', '=', true]]).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchProductProduct: function() {
            var self = this;
            var defer = $.Deferred();
            var ProductProduct = new instance.web.Model('product.product');
            ProductProduct.query(['id', 'name','ean13','default_code','attribute_str']).filter([['active', '=', true]]).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        fetchStockLocation : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id', 'name', 'location_id'];
            var domain =[['usage', 'not in', ['view','transit','production','procurement']],['scrap_location','=',false],['active','!=',false]];
            var StockLocation = new instance.web.Model('stock.location');
            StockLocation.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },
        search: function () {
            var self = this;
            var results = self.ResPartner;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
                        value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
                }
            });
            self.$('#partner').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#partner').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },
        searchProduct: function () {
            var self = this;
            var results = self.ProductProduct;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) ' ,
                        value: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) '
                }
            });
            self.$('#product').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#product').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },
        BuildTable: function(){
            var self = this;
            var StockMove = self.StockMove;
            var data = [];
            var origin;
            _.each(StockMove, function(item){
                data.push({
                    id : item.id,
                    name : item.name,
                    picking_name : self.valorNull(item.picking_id[1]),
                    origin_name : self.valorNull(item.origin),
                    product_name : item.product_id[1],
                    product_uom_qty : item.product_uom_qty,
                    date_move : moment(item.date).format("DD/MM/YYYY"),
                    partner_name : self.valorNull(item.partner_id[1]),
                    location : item.location_id[1],
                    location_dest : item.location_dest_id[1],
                    picking_id : item.picking_id[0],
                    product_id : item.product_id[0],
                    partner_id : item.partner_id[0],
                    date : moment(item.date).format("YYYY-MM-DD"),
                    location_id : item.location_id[0],
                    location_dest_id : item.location_dest_id[0],
                });
            });
            self.content = data;
            this.loadTable(data);
        },
        factSearch: function(){
            var self = this;
            var hoy = moment().format('YYYY-MM-DD');
            var desde = this.$el.find('#from').val();
            var hasta = this.$el.find('#to').val();
            var location_id = this.$el.find('#current-location-origin').val();
            var location_dest_id = this.$el.find('#current-location-destiny').val();
            var partner = this.$el.find('#partner').val().split('-');
            var product = this.$el.find('#product').val().split('-');
            var content = self.content;
            if ($('#A').is(":checked")){
                content = _.filter(content, function (inv){
                    return inv.date == hoy;
                });
            }
            if ($('#B').is(":checked")){
                var date = hoy.split('-');
                var ayer = date[2] - 1;
                date.splice(2,0);
                if(date[2] < 10){
                    date[2] = '0'+ayer;
                }else{
                    date[2] = ayer;
                }
                content = _.filter(content, function (inv){
                    return inv.date == date[0]+'-'+date[1]+'-'+date[2];
                });
            }
            if ($('#C').is(":checked")){
                var date = hoy.split('-');
                content = _.filter(content, function (inv){
                    var mes = inv.date.split('-');
                    return mes[0]+'-'+mes[1] == date[0]+'-'+date[1];
                });
            }
            if ($('#D').is(":checked")){
                var date = hoy.split('-');
                var mes = date[1] - 1;
                var year;
                date.splice(1,0);
                if(date[1] == 1){
                    date[1] = '12';
                    year = date[0] - 1;
                    date[0] = year;
                }else{

                 if(date[1] < 10){
                     date[1] = '0'+mes;
                 }else{
                     date[1] = mes;
                 }
                }
                content = _.filter(content, function (inv){
                    var mes = inv.date.split('-');
                    return mes[0]+'-'+mes[1] == date[0]+'-'+date[1];
                });
            }
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date= desde.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }
            if (partner != ''){
                content = _.filter(content, function(inv){
                    return inv.partner_id == partner[0];
                });
            }
            if (product != ''){
                content = _.filter(content, function(inv){
                    return inv.product_id == product[0];
                });
            }
            if (location_id != 9999999){
                content = _.filter(content, function(inv){
                    return inv.location_id == location_id;
                });
            }
            if (location_dest_id != 9999999){
                content = _.filter(content, function(inv){
                    return inv.location_dest_id == location_dest_id;
                });
            }

            var amount_total_total = _.reduce(_.map(content,function(map){
                return(map.product_uom_qty);
            }),function(memo, num){
                return memo + num;
            },0);

            content.push({
                picking_name: "Total",
                product_uom_qty: accounting.formatNumber((amount_total_total),0,".",","),
            });

            self.loadTable(content)
        },
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },
        getObjectPdf: function(rowsTable){
            var self = this;
            var rows=self.rowsData;
            var product_uom_qty = _.reduce(_.map(rows,function(map){
                return(map.product_uom_qty);
            }),function(memo, num){
                return memo + num;
            },0);
            if (rows.length > 0){
                rows.push({
                    product_uom_qty: accounting.formatNumber((product_uom_qty),0,".",","),
                });
            }
            return rows;
        },
        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjectPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                            getColumns.push([{
                                        title: item.title,
                                        dataKey: item.field
                                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
        },
        drawPDF: function (getColumns,rows) {
            var self = this;
            var hoy = moment().format('DD/MM/YYYY');
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF('l');

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                    picking_name : {columnWidth: '8px'},
                    origin_name : {columnWidth: '8px'},
                    product_name : {columnWidth: '8px'},
                    partner_name : {columnWidth: '8px'},
                    product_uom_qty : {halign:'center',columnWidth: '8px'},
                    date_move : {columnWidth: '8px'},
                    location : {columnWidth: '8px'},
                    location_dest : {columnWidth: '8px'},
                },
                margin: { top: 20, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Análisis de Movimientos de Stock', 115, 10);

                    var fecha = '';
                    if ($('#X').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Sin Filtros' );
                    }
                    if ($('#A').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Hoy' );
                    }
                    if ($('#B').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Ayer' );
                    }
                    if ($('#C').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Mes Actual' );
                    }
                    if ($('#D').is(":checked")){
                        fecha = fecha.concat(' Filtro de fecha : Mes Pasado' );
                    }
                    if ($('#Z').is(":checked")){
                        if(desde.length > 0 || hasta.length > 0){
                            if(desde){
                                fecha=fecha.concat(' Desde: '+ desde);
                            }
                            if (hasta){
                                fecha=fecha.concat(' Hasta: '+ hasta);
                            }
                        }
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(6,18,fecha);

                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40)
                    pdfDoc.text(240,18," Fecha de Expedición: " + hoy);

                    var str = " Pagina  " + data.pageCount;
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(260,pdfDoc.internal.pageSize.height - 5,str);
                    }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Análisis de Movimientos de Stock.pdf')
        },
    });
}
