function report_stock_original (reporting){
    "use strict";

    var instance = openerp;

    reporting.ReportStockOriginalWidget = reporting.Base.extend({
        template: 'ReportStockOriginal',
        stockLocation: [],
        stockQuant: [],
        productProduct : [],
        rowsData: [],
        content: [],
        newStock: [],

        events : {
            'change #current-location' : 'factSearch',
            'change #current-category' : 'factSearch',
            'click #Y' : 'factSearch',
            'click #disponible' : 'factSearch',
            'click #nodisponible' : 'factSearch',
            'click #toolbar > button' : 'clickOnAction',
            'click-row.bs.table #table ' : 'clickAnalysisDetail',
        },
        init : function(parent){
            this._super(parent);
        },
        start : function(){
            var self = this;
            var dato=[];
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            self.submitForm();
        },
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },
        clickAnalysisDetail: function(e, row, $element,field){
            if (field == 'product'){
                this.do_action({
                    name:"Variantes de Producto",
                    type: 'ir.actions.act_window',
                    res_model: "product.product",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id', '=',row.id ]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.id,
                });
            }
            e.stopImmediatePropagation();
        },
        submitForm: function(){
            var self = this;
            self.fecthProductProduct().then(function(ProductProduct){
                return ProductProduct;
            }).then(function (ProductProduct){
                self.ProductProduct = ProductProduct;
                return self.fecthStockLocation();
            }).then(function(StockLocation){
                self.StockLocation = StockLocation;
                self.$el.find('#current-location').append('<option value="9999999">Todas las Ubicación.</option>');
                _.each(StockLocation,function(item){
                    self.$el.find('#current-location').append('<option value="' + item.id + '">' + item.location_id[1]+" / "+item.name + '</option>');
                });
                return self.fecthStockQuant();
            }).then(function(StockQuant){
                self.StockQuant = StockQuant;
                return self.fecthProductCategory();
            }).then(function(ProductCategory){
                self.ProductCategory = ProductCategory;
                self.$el.find('#current-category').append('<option value="9999999">Todos las categorias</option>');
                _.each(ProductCategory, function (item) {
                    self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                self.searchProduct();
                return self.BuildTable();
            });
        },
        fecthProductProduct: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name_template','ean13','categ_id','attribute_str'];
            var domain =[['active', '=', true],['type', '=', 'product']];
            var ProductProduct =  new instance.web.Model('product.product');
            ProductProduct.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },

        fecthStockLocation : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id', 'name','location_id'];
            var domain =[['active', '=', true],['usage', '=', 'internal']];
            var StockLocation = new instance.web.Model('stock.location');
            StockLocation.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },

        fecthStockQuant : function(){
            var self = this;
            var defer = $.Deferred();
            var location = _.flatten(_.map(self.StockLocation,function(item){
                return item.id;
            }));
            var fields = ['id', 'product_id', 'qty', 'cost','location_id'];
            var domain =[['location_id', 'in',location]];
            var StockLocation = new instance.web.Model('stock.quant');
            StockLocation.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },

        fecthProductCategory: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'type'];
            var ProductCategory =  new instance.web.Model('product.category');
            ProductCategory.query(fields).filter([['type', '=', 'normal']]).all().then(function (results) {
              defer.resolve(results)
            });
            return defer;
        },

        getStockQuant: function(id){
            var self = this;
            return _.filter(self.StockQuant, function(item){
                return item.product_id[0] === id;
            });
        },

        searchProduct: function () {
            var self = this;
            var results = self.productProduct;
            results = _.map(results, function (item) {
                return {
                    label: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) ' ,
                    value: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) '
                }
            });
            self.$('#product').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#product').val())){
                        self.factSearch();
                    }
                },
                close: function( event, ui ) {
                        self.factSearch();
                },
                select: function(event, ui) {
                    self.factSearch();
                }
            });
        },

        BuildTable : function(){
            var self = this;
            var ProductProduct = self.ProductProduct;
            var data=[];
            var attribute;
            _.each(ProductProduct, function(item){

                if(item.attribute_str){
                    attribute = ' ' + item.attribute_str;
                }else{
                    attribute = ' ';
                }
                var quant = self.getStockQuant(item.id);

                var quantity = 0;

                if (quant.length > 0){

                    quantity = _.reduce(_.map(quant,function(item){
                        return item.qty;
                    }),function(mamo, num){
                        return mamo + num;
                    },0);
                }

                data.push({
                    id : item.id,
                    product : item.name_template + attribute,
                    category_name : item.categ_id[1],
                    qty : accounting.formatNumber(quantity,2, ".", ","),
                    category : item.categ_id[0],
                });
            });

            self.content = data;
            self.loadTable(data);
        },

        getQuantProduct: function(content,location){
            var self = this;
            var data=[];
            _.each(content, function(inv){
                var quant = _.filter(self.StockQuant, function(item){
                    return item.location_id[0] == location & item.product_id[0] == inv.id;
                });
                var quantity = 0;
                if (quant.length > 0){
                    quantity = _.reduce(_.map(quant,function(item){
                        return item.qty;
                    }),function(mamo, num){
                        return mamo + num;
                    },0);
                }
                inv.qty = accounting.formatNumber(quantity,2, ".", ",");
            });
            return content;
        },

        factSearch: function(){
            var self = this;
            var category = this.$el.find('#current-category').val().split('-');
            var location =this.$el.find('#current-location').val();
            var content = self.content;

            if (location != 9999999){
                content = self.getQuantProduct(content,location);
            }

            if (location = 9999999){
                self.BuildTable();
            }

            if(category != 9999999){
                content = _.filter(content,function(inv){
                    return inv.category == category[0];
                });
            }

            if ($('#disponible').is(":checked")){
                content = _.filter(content, function(inv){
                    return parseFloat(inv.qty) > 0;
                });
            }
            if ($('#nodisponible').is(":checked")){
                content = _.filter(content, function(inv){
                    return parseFloat(inv.qty) <= 0;
                });
            }

            self.loadTable(content)
        },


        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = self.$el.find('#table');
            table.bootstrapTable('load' ,rowsTable);
        },
        getObjectPdf: function(){
            var self = this;
            var rows=[];
            var rows = self.rowsData;

            return rows;
        },
        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = self.$el.find(e.target).val();
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjectPdf();
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                        return val;
                    }), function(item){
                            getColumns.push([{
                                        title: item.title,
                                        dataKey: item.field
                                    }]);
                });
                this.drawPDF(_.flatten(getColumns),rows);
            }
        },
        drawPDF:function(getColumns,rows){
            var self = this;
            var fechaActu= new Date();
            var location = this.sucDescrip = this.$el.find('#current-location option:selected').text();
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();
            pdfDoc.autoTable(getColumns, rows, {
                    styles: { overflow: 'linebreak', fontSize:8 , columnWidth: 'wrap'},
                    columnStyles:{
                                    product :{columnWidth: '8px'},
                                    qty : {halign:'center'},
                                    category_name :{columnWidth: '8px'},
                                    location_id :{columnWidth: '8px'},
                                },
                    margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Listado de productos', data.settings.margin.left, 10);
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                        // +"\n  Día de Expedición  "+fechaActu.getDate()+"/"+fechaActu.getMonth()+"/"+fechaActu.getFullYear();
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                }
            });
            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Listado de productos.pdf');
        }
    });
}
