function report_ventas_pos_orders(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportVentasPosOrdersWidget = reporting.Base.extend({
        template: 'ReportVentasPosOrders',
        rowsData :[],
        modules:[],
        PosOrderLine: [],
        accountJournal:[],
        productProduct:[],
        productInvoice:[],
        invoices: [],
        invoiceLines: [],
        PosOrder: [],
        content:[],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #X' : 'fectSearch',
            'click #A' : 'fectSearch',
            'click #B' : 'fectSearch',
            'click #C' : 'fectSearch',
            'click #D' : 'fectSearch',
            'click #Z' : 'fectSearch',
            'change #current-store': 'fectSearch',
            'change #from' : 'fectSearch',
            'change #to': 'fectSearch',
            'click-row.bs.table #table' : 'clickAnalysisDetail',
        },

        init : function(parent){
          this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowData});
            this.fecthFecha();
            this.submitForm();
        },

        // Redirecionar
        renderReport: function () {
            var self = this;

            var container = this.$el.closest('.oe_form_sheet.oe_form_sheet_width');
            this.$el.closest('.report_view').remove();
            container.find('.report_view').show({
                effect: 'fade',
                duration: 200,
            });
        },

        // Verificar el modelo
        checkModel : function(model){
            var self = this;
            return _.filter(self.modules,function(item){return item.name === model});
        },

        // Lanzar el mensaje
        showMensaje : function(modelos){
            var self = this;
            $("#dialog" ).dialog({
                autoOpen: true,
                resizable: false,
                modal: true,
                title: 'Atención',
                width: 500,
                open: function() {
                    $(this).html('Reporte in-disponible, contacte con el administrador del sistema ref : '+modelos);
                },
                show: {
                    effect: "fade",
                    duration: 200
                },
                hide: {
                    effect: "fade",
                    duration: 200
                },
                buttons: {
                    Aceptar: function() {
                        $(this).dialog('close');
                        self.renderReport()
                    }
                }
            });
            return
        },

        clickAnalysisDetail: function(e, row, $element, field){
            if (field == 'ref'){
                this.do_action({
                    name:"Factura de cliente",
                    type: 'ir.actions.act_window',
                    res_model: "account.invoice",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['type', '=', 'out_invoice'],['id','=', row.order_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.order_id,
                });
            }
            if (field == 'order_name'){
                this.do_action({
                    name:"Pos",
                    type: 'ir.actions.act_window',
                    res_model: "pos.order",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.id,
                });
            }
            if (field == 'product_name'){
                this.do_action({
                    name : "Productos",
                    type : 'ir.actions.act_window',
                    res_model : "product.product",
                    views : [[false,'form']],
                    target : 'new',
                    domain : [['id','=', row.product_id]],
                    context : {},
                    flags : {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id : row.product_id,
                });
            }
            e.stopImmediatePropagation();
        },

        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
                from = $( "#from" )
                .datepicker({
                  dateFormat: "dd/mm/yy",
                  changeMonth: true,
                  numberOfMonths: 1,
                })
                .on( "change", function() {
                  to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
                });
                to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
                })
                .on( "change", function() {
                    from.datepicker( "option", "maxDate", getDate(this));
                });
            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
                return date;
            }
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        // Consultar
        submitForm: function () {
            var self = this;
            self.fecthIrModuleModule().then(function(modules){
                self.modules = modules;
                return modules;
            }).then(function(modules){
                return self.fetchPosOrder();
            }).then(function(PosOrder) {
                self.PosOrder = PosOrder;
                return PosOrder;
            }).then(function (PosOrder) {
                return self.fetchPosOrderLine();
            }).then(function (PosOrderLine) {
                self.PosOrderLine = PosOrderLine;
                return self.fetchProductProduct();
            }).then(function (ProductProduct) {
                self.ProductProduct = ProductProduct;
                return self.fecthResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                self.$el.find('#current-store').append('<option value="9999999">Todas las SUC.</option>');
                _.each(ResStore,function(item){
                self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
            });
                return self.fecthAccountJournal();
            }).then(function(AccountJournal){
                self.AccountJournal = AccountJournal;
                return self.fetchInvoiceV2();
            }).then(function (invoices){
                self.invoices = invoices;
                return self.fetchInvoiceLine(invoices);
            }).then(function (invoiceLines) {
                self.invoiceLines = invoiceLines;
                return self.fecthProduct(invoiceLines);
            }).then(function(ProductInvoice){
                self.ProductInvoice = ProductInvoice;
                return self.fetchResPartner();
            }).then(function (ResPartner){
                self.ResPartner = ResPartner;
                self.search();
                self.searchProduct();
                return self.BuildTable();
            });
        },

        // Modelos instalados
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed']];
            var irModule = new model.web.Model('ir.module.module');

            irModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fecthAccountJournal: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id', 'name','store_ids'];
            var domain = [['active','=',true],['type','in',['sale','purchase']]];
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        // Invoice (FACTURAS)
        fetchInvoiceV2: function () {
            var self = this;
            var filter ="[['state', 'in',['open','paid']],['type', '=', 'out_invoice']";
            var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                return item.id;
            }));
            if (journal_ids){
                filter=filter.concat(",['journal_id', 'in',["+journal_ids+"]]");
            }
            filter=filter.concat("]");
            var field =['id', 'type', 'number', 'origin', 'state', 'journal_id', 'currency_id', 'invoice_line','date_invoice','partner_id'];
            var defer = $.Deferred();
            var Invoice = new model.web.Model('account.invoice');
            Invoice.query(field).filter(filter).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        // Invoice line (Linea de Factura)
        fetchInvoiceLine: function (invoices) {
            var self = this;
            var defer = $.Deferred();
            var linesIds = _.flatten(_.map(self.invoices, function (item) {
                return item.invoice_line;
            }));
            var InvoiceLine = new model.web.Model('account.invoice.line');
            InvoiceLine.query(['id', 'quantity', 'price_unit', 'discount', 'name', 'product_id', 'origin','invoice_id']).filter([['id', 'in', linesIds]]).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },

        // clientes
        fetchResPartner: function () {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','ruc'];
            var domain = [['active', '=', true],['customer', '=', true]];
            var ResPartner = new model.web.Model('res.partner');
            ResPartner.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        // Product Product
        fecthProduct: function(invoiceLines){
            var self = this;
            var defer = $.Deferred();
            var porductIDS = _.flatten(_.map(self.invoiceLines, function (item) {
                return item.product_id[0];
            }));
            var ProductInvoice =  new model.web.Model('product.product');
            var fields = ['id','name', 'default_code', 'name_template','ean13', 'standard_price','type','attribute_str'];
            ProductInvoice.query(fields).filter([['id', 'in', porductIDS]]).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },

        // Ventas (Point Of Sale)
        fetchPosOrder: function () {
            var self = this;
            var defer = $.Deferred();
            // var modules = self.checkModel('point_of_sale');
            //
            // if (modules.length <= 0){
            //     self.showMensaje('point_of_sale');
            //     return defer;
            // }

            var fields = ['id','name','partner_id','create_date','lines','table_id','sale_journal'];
            var domain = [['state', 'not in', ['draft','cancel']]];
            var PosOrder = new model.web.Model('pos.order');
            PosOrder.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        // Lineas de venta (Point Of Sale)
        fetchPosOrderLine: function () {
            var self = this;
            var defer = $.Deferred();
            var ids = _.flatten(_.map(self.PosOrder, function (item) {
                return item.lines;
            }));
            var fields = ['id', 'name', 'order_id', 'product_id', 'qty', 'price_unit', 'price_subtotal_incl']
            var domain = [['order_id', 'in', ids]];
            var PosOrderLine = new model.web.Model('pos.order.line');
            PosOrderLine.query().filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        // Productos
        fetchProductProduct: function(){
            var self = this;
            var defer = $.Deferred();
            var porduct_ids = _.flatten(_.map(self.PosOrderLine, function (item) {
                return item.product_id[0];
            }));
            var fields = ['id','name', 'default_code', 'name_template','ean13','lst_price','pos_categ_id', 'standard_price','type','attribute_str'];
            var domain = [['id', 'in', porduct_ids]];
            var ProductProduct =  new model.web.Model('product.product');
            ProductProduct.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        getPosOrder: function(id){
            var self = this;
            return _.filter(self.PosOrder,function (item) {
                return item.id == id;
            });
        },

        // Obtener las lineas de las Facturas
        getProductProduct: function(id){
            var self = this;

            return _.filter(self.ProductProduct, function(item){
                return item.id === id;
            });
        },

        // Obtener las lineas de las Facturas
        getProductInvoice: function(id){
            var self = this;
            return _.filter(self.ProductInvoice, function(item){
                return item.id === id;
            });
        },

        getAccountJournal: function (id) {
            var self = this;
            return _.filter(self.AccountJournal,function (item) {
                return item.id === id;
            });
        },

        search: function () {
            var self = this;
            var results = self.ResPartner;
            results = _.map(results, function (item) {
                return {
                        label: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc),
                        value: item.id + '-'+ item.name + ' ' + self.valorNull(item.ruc)
                }
            });
            self.$('#partner').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#partner').val())){
                        self.fectSearch();
                    }
                },
                close: function( event, ui ) {
                        self.fectSearch();
                },
                select: function(event, ui) {
                    self.fectSearch();
                }
            });
        },


        // Obtener Pedido
        fecthResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field=['id', 'name'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        // Obtener la Detalles de la Factura
        getInvoice: function (id_line){
            return _.find(this.invoices, function (inv) {
                return _.contains(inv.invoice_line, id_line);
            });
        },

        getAccountJournalVentas: function (id) {
            var self = this;
            return _.filter(self.AccountJournal,function (item) {
                return item.id === id;
            });
        },

        BuildTable: function(){
            var self = this;
            var data = [];
            var order;
            var sale;
            var itemsale;
            var producto = [];
            var saleproducto = [];
            var item;

            for (var i = 0; i < this.PosOrderLine.length; i++) {


                item = this.PosOrderLine[i];
                producto = self.getProductProduct(item.product_id[0]);
                order = self.getPosOrder(item.order_id[0]).shift();
                var utc = moment.utc(item.create_date,'YYYY-MM-DD h:mm:ss A');
                var date = moment(utc._d).format('DD/MM/YYYY h:mm A');
                var date_aux=moment(utc._d).format('YYYY-MM-DD');
               var store = self.getAccountJournal(order.sale_journal[0]);

                if(store.length > 0 && producto.length > 0){

                    data.push({
                        id : item.id,
                        order_id : item.order_id[0],
                        ref: "",
                        order_name : item.order_id[1],
                        date : date_aux,
                        date_order : date,
                        partner: order.partner_id[1],
                        product_id : item.product_id[0],
                        product_name : item.product_id[1],
                        qty : accounting.formatNumber(item.qty,0,".",","),
                        price_unit : accounting.formatNumber(item.price_unit,0,".",","),
                        standard_price : accounting.formatNumber((producto[0].standard_price),0, ".", ","),
                        price_tot : accounting.formatNumber((item.qty * item.price_unit),0, ".", ","),
                        standar_tot : accounting.formatNumber((item.qty * producto[0].standard_price),0, ".", ","),
                        utility : accounting.formatNumber(((item.qty * item.price_unit) - (item.qty * producto[0].standard_price)),0, ".", ","),
                        qty_total : item.qty,
                        price_tot_tot : ((item.qty * item.price_unit)),
                        standar_tot_tot : ((item.qty * producto[0].standard_price)),
                        partner_id : order.partner_id[0],
                        utility_tot : (((item.qty * item.price_unit) - (item.qty * producto[0].standard_price))),
                        store_id : store[0].store_ids[0],
                    });
                }
            }

            for (var k = 0; k < this.invoiceLines.length; k++) {
                itemsale = this.invoiceLines[k];

                sale = this.getInvoice(itemsale.id);

                saleproducto = this.getProductInvoice(itemsale.product_id[0]);


                 if (!saleproducto){
                     saleproducto={};
                     saleproducto.standard_price=0;
                 }

                var storeVenta = self.getAccountJournalVentas(sale.journal_id[0]);
                if (!storeVenta){
                    storeVenta={};
                    storeVenta.standard_price=0;
                }
                if(storeVenta.length > 0 && saleproducto.length > 0){
                    data.push({
                        id : itemsale.id,
                        order_id : itemsale.invoice_id[0],
                        ref: itemsale.invoice_id[1],
                        order_name : "",
                        date : sale.create_date,
                        date_order : moment(sale.create_date).format("DD/MM/YYYY"),
                        partner: sale.partner_id[1],
                        product_id : itemsale.product_id[0],
                        product_name : itemsale.product_id[1],
                        qty : accounting.formatNumber(itemsale.quantity,0,".",","),
                        price_unit : accounting.formatNumber(itemsale.price_unit,0,".",","),
                        standard_price : accounting.formatNumber((saleproducto[0].standard_price),0, ".", ","),
                        price_tot : accounting.formatNumber((itemsale.quantity * itemsale.price_unit),0, ".", ","),
                        standar_tot : accounting.formatNumber((itemsale.quantity * saleproducto[0].standard_price),0, ".", ","),
                        utility : accounting.formatNumber(((itemsale.quantity * itemsale.price_unit) - (itemsale.quantity * saleproducto[0].standard_price)),0, ".", ","),
                        qty_total : itemsale.quantity,
                        price_tot_tot : ((itemsale.quantity * itemsale.price_unit)),
                        standar_tot_tot : ((itemsale.quantity * saleproducto[0].standard_price)),
                        partner_id : sale.partner_id[0],
                        utility_tot : (((itemsale.quantity * itemsale.price_unit) - (itemsale.quantity * saleproducto[0].standard_price))),
                        store_id : storeVenta[0].store_ids[0],
                    });
                }
            }
            this.rowsData=data;
            self.content=data;
            this.loadTable(data)
        },

        fectSearch: function(){
            var self = this;
            var today = moment().format('YYYY-MM-DD');
            var yesterday = moment().add(-1, 'days').format('YYYY-MM-DD');
            var month = moment().format('YYYY-MM');
            var last_month = moment().add(-1, 'months').format('YYYY-MM');
            var desde =this.$el.find('#from').val();
            var hasta =this.$el.find('#to').val();
            var store = this.$el.find('#current-store').val();
            var partner= this.$el.find('#partner').val().split('-');
            var product = this.$el.find('#product').val().split('-');
            var content = self.content;

            // Hoy
            if ($('#A').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM-DD') == today;
                });
            }
            if ($('#B').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM-DD') == yesterday;
                });
            }
            if ($('#C').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM') == month;
                });
            }
            if ($('#D').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM') == last_month;
                });
            }
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date= desde.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }

            // Buscar Producto
            if (product != ""){
                content = _.filter(content, function(inv){
                    return inv.product_id == product[0];
                });
            }

            if (partner != ""){
                content = _.filter(content, function(inv){
                    return inv.partner_id == partner[0];
                });
            }

            if (store != 9999999){
                content=_.filter(content, function (inv){
                    return inv.store_id == store;
                });
            }

            var qty_total_total = _.reduce(_.map(content,function(map){
                return(map.qty_total);
            }),function(memo, num){
                return memo + num;
            },0);

            var price_total_total = _.reduce(_.map(content,function(map){
                return(map.price_tot_tot);
            }),function(memo, num){
                return memo + num;
            },0);

            var standar_total_total = _.reduce(_.map(content,function(map){
                return(map.standar_tot_tot);
            }),function(memo, num){
                return memo + num;
            },0);

            var utilidad_total_total = _.reduce(_.map(content,function(map){
                return(map.utility_tot);
            }),function(memo, num){
                return memo + num;
            },0);

            content.push({
                order_name: "Total",
                qty: accounting.formatNumber((qty_total_total),0,".",","),
                price_tot: accounting.formatNumber((price_total_total),0,".",","),
                standar_tot: accounting.formatNumber((standar_total_total),0,".",","),
                utility: accounting.formatNumber((utilidad_total_total),0,".",","),
            });

            self.loadTable(content)
        },

        searchProduct: function () {
            var self = this;
            var results = self.ProductProduct;
            results = _.map(results, function (item) {
                return {
                    label: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) ' ,
                    value: item.id + '- '+ ' [ ' + self.valorNull(item.default_code) + ' - ' + self.valorNull(item.ean13) + ' ] ' + item.name + ' ( ' +  self.valorNull(item.attribute_str) + ' ) '
                }
            });
            self.$('#product').autocomplete({
                source: results,
                minLength:0,
                search: function(event, ui) {
                    if (!(self.$('#product').val())){
                        self.fectSearch();
                    }
                },
                close: function( event, ui ) {
                        self.fectSearch();
                },
                select: function(event, ui) {
                    self.fectSearch();
                }
            });
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },

        getObjetPdf: function(rowsTable){
            var self = this;
            var rows=[];
            var rows = self.rowsData;

            // var qty =_.reduce(_.map(rows,function(map){
            //     return(map.qty_total);
            // }),function(memo, num){
            //     return memo + num;
            // },0);
            //
            // var price_tot =_.reduce(_.map(rows,function(map){
            //     return(map.price_tot_tot);
            // }),function(memo, num){
            //     return memo + num;
            // },0);
            //
            // var standar_tot =_.reduce(_.map(rows,function(map){
            //     return(map.standar_tot_tot);
            // }),function(memo, num){
            //     return memo + num;
            // },0);
            //
            // var utility =_.reduce(_.map(rows,function(map){
            //     return(map.utility_tot);
            // }),function(memo, num){
            //     return memo + num;
            // },0);
            //
            // if (rows.length > 0){
            //     rows.push({
            //             order_name : "Totales ",
            //             qty : accounting.formatNumber(qty,0,".",","),
            //             price_tot : accounting.formatNumber(price_tot,0,".",","),
            //             standar_tot : accounting.formatNumber(standar_tot,0,".",","),
            //             utility : accounting.formatNumber(utility,0,".",","),
            //     });
            // }
            return rows;
        },

        clickOnAction: function (e) {
            var self = this;
            var rowsNew;
            var action = this.$el.find(e.target).val();
            var table = this.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            var getColumns=[];
            var rows=[];
            rowsNew = self.getObjetPdf();

            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){ return val.field});
                _.each(rowsNew,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                    return val}), function(item){
                    getColumns.push([{
                                    title: item.title,
                                    dataKey: item.field
                                }]);
                });
                // Llamar al pdf
                this.drawPDF(_.flatten(getColumns),rows)
            }
        },

        drawPDF: function (getColumns,rows) {
            var self = this;
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF('l');

            pdfDoc.autoTable(getColumns, rows, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                        order_name: {halign:'left', fontStyle: 'bold'},
                        ref: {halign:'left', fontStyle: 'bold'},
                        date_order :{halign:'left'},
                        partner :{halign:'left' },
                        product_name :{halign:'left' },
                        qty :{halign:'right' },
                        price_unit : {halign:'right' },
                        standard_price : {halign:'right' },
                        price_tot : {halign:'right' },
                        standar_tot : {halign:'right' },
                        utility : {halign:'right'}
                    },
                margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Análisis de Ventas generales', data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                      var fecha='';
                      if(desde){
                        fecha=fecha.concat(' Desde '+desde);
                      }
                      if (hasta){
                        fecha=fecha.concat(' Hasta '+hasta);
                      }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Análisis de ventas generales.pdf')
        },
    });
}
